(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     31977,        877]
NotebookOptionsPosition[     28952,        818]
NotebookOutlinePosition[     29305,        834]
CellTagsIndexPosition[     29262,        831]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Session 1 : Exercises", "Title",
 CellChangeTimes->{{3.7733902718969593`*^9, 
  3.773390277718581*^9}},ExpressionUUID->"b468e586-f10e-4d47-a7bf-\
19a2822df633"],

Cell[TextData[{
 "We consider a graph consisting of ",
 Cell[BoxData[
  FormBox["m", TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "f872ea81-c953-4bff-a62e-483fe84cbde7"],
 " parallel edges from ",
 Cell[BoxData[
  FormBox["s", TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "2254030d-547e-4f60-a47a-e662c25be65a"],
 " to ",
 Cell[BoxData[
  FormBox["t", TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "4d918ab9-fe01-4b69-a128-a33159bf6914"],
 ". Each edge is equipped with a (affine linear) non-negative cost function \
",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["c", "e"], "(", 
    SubscriptBox["x", "e"], ")"}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "953608dc-2623-4980-9a53-1e7510599ffa"],
 ".\n",
 Cell[BoxData[
  GraphicsBox[
   NamespaceBox["NetworkGraphics",
    DynamicModuleBox[{Typeset`graph = HoldComplete[
      Graph[{$CellContext`s, $CellContext`t}, {{{1, 2}, {1, 2}, {1, 2}, {1, 
        2}}, Null}, {
       EdgeLabels -> {
         "\!\(TraditionalForm\`\*SubscriptBox[\(c\), \
\(e\)](\*SubscriptBox[\(x\), \(e\)])\)"}, VertexLabels -> {"Name"}, 
        VertexCoordinates -> {{0, 0}, {1, 0}}}]]}, 
     TagBox[GraphicsGroupBox[{
        {Hue[0.6, 0.7, 0.5], Opacity[0.7], Arrowheads[
         Medium], {
          ArrowBox[BezierCurveBox[{{0., 0.}, {0.5000000000000004, 
           0.1644407471831171}, {1., 0.}}], 0.01273], 
          InsetBox["\<\"\\!\\(TraditionalForm\\`\\*SubscriptBox[\\(c\\), \\(e\
\\)](\\*SubscriptBox[\\(x\\), \\(e\\)])\\)\"\>", {0.5000000000000001, 0.07000000000000006},
            ImageScaled[{0.5, 0.5}],
           BaseStyle->"Graphics"]}, {
          ArrowBox[BezierCurveBox[{{0., 0.}, {0.5000000000000148, 
           0.05497866964731282}, {1., 0.}}], 0.01273], 
          InsetBox["\<\"\\!\\(TraditionalForm\\`\\*SubscriptBox[\\(c\\), \\(e\
\\)](\\*SubscriptBox[\\(x\\), \\(e\\)])\\)\"\>", {0.5, 0.023333333333333428}, 
           ImageScaled[{0.5, 0.5}],
           BaseStyle->"Graphics"]}, {
          ArrowBox[BezierCurveBox[{{0., 0.}, {
           0.5000000000000148, -0.05497866964731282}, {1., 0.}}], 0.01273], 
          InsetBox["\<\"\\!\\(TraditionalForm\\`\\*SubscriptBox[\\(c\\), \\(e\
\\)](\\*SubscriptBox[\\(x\\), \\(e\\)])\\)\"\>", {0.5, -0.023333333333333428},
            ImageScaled[{0.5, 0.5}],
           BaseStyle->"Graphics"]}, {
          ArrowBox[BezierCurveBox[{{0., 0.}, {
           0.5000000000000004, -0.1644407471831171}, {1., 0.}}], 0.01273], 
          InsetBox["\<\"\\!\\(TraditionalForm\\`\\*SubscriptBox[\\(c\\), \\(e\
\\)](\\*SubscriptBox[\\(x\\), \\(e\\)])\\)\"\>", {0.5000000000000001, -0.07000000000000006},
            ImageScaled[{0.5, 0.5}],
           BaseStyle->"Graphics"]}}, 
        {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[
         0.7]}], {DiskBox[{0., 0.}, 0.01273], 
          InsetBox["s", Offset[{2, 2}, {0.01273, 0.01273}], ImageScaled[{0, 0}],
           BaseStyle->"Graphics"]}, {DiskBox[{1., 0.}, 0.01273], 
          InsetBox["t", Offset[{2, 2}, {1.01273, 0.01273}], ImageScaled[{0, 0}],
           BaseStyle->"Graphics"]}}}],
      MouseAppearanceTag["NetworkGraphics"]],
     AllowKernelInitialization->False]],
   DefaultBaseStyle->{
    "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
   FormatType->TraditionalForm,
   FrameTicks->None]],
  CellChangeTimes->{{3.773390713036853*^9, 3.773390726247188*^9}, 
    3.7733908072968483`*^9, {3.773390862300686*^9, 3.77339088935953*^9}},
  ExpressionUUID->"baed40fe-7b74-4167-bc8a-bf7791df741f"],
 "\nA Wardrop Equilibrium is a s-t-Flow such that ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["c", "P"], "(", 
     SubscriptBox["x", "P"], ")"}], "\[LessEqual]", 
    RowBox[{
     SubscriptBox["c", "Q"], "(", 
     SubscriptBox["x", "Q"], ")"}]}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "cfa55fba-7169-4e4f-9e59-cbde6386fc06"],
 "for all s-t-paths ",
 Cell[BoxData[
  FormBox["P", TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "21aa8549-88a2-4cf6-b49f-ad9100bfe36d"],
 " and ",
 Cell[BoxData[
  FormBox["Q", TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "b3429f50-24c3-43bd-b759-30736ed26c3d"],
 " with ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", "P"], ">", "0"}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "50c5e611-1372-4ff9-9d32-8ce9d9f0794e"],
 ". This means, every path with a positive amount of flow must have the same, \
minimal cost. Unused paths (with ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", "P"], "=", "0"}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "e32f3646-6092-4530-9dca-ed4c3a1932a7"],
 ") can have higher cost.\nIn this simple setting, this means we search flow \
values ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", "1"], ",", "...", ",", 
    RowBox[{
     SubscriptBox["x", "m"], "\[GreaterEqual]", "0"}]}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "027023e9-d8cc-4886-8ea9-090e458a70a7"],
 " such that ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"\[Sum]", 
     SubscriptBox["x", "i"]}], "=", "r"}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "283e9ae8-b4a8-4402-82c6-ce1d2bcd36d9"],
 " (where ",
 Cell[BoxData[
  FormBox["r", TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "cbc7076e-a590-464c-b0fb-272a607e46e0"],
 " is some given demand rate) such that ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["c", "i"], "(", 
     SubscriptBox["x", "i"], ")"}], "=", 
    RowBox[{
     SubscriptBox["min", "j"], 
     RowBox[{
      SubscriptBox["c", "j"], "(", 
      SubscriptBox["x", "j"], ")"}]}]}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "393e60f1-c363-425d-8e9f-041ec5bb1986"],
 " whenever ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", "i"], ">", "0"}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "e4553620-4141-46ad-b382-2352b2f8c6a2"],
 "."
}], "Text",
 CellChangeTimes->{{3.773390422353694*^9, 3.7733904237175417`*^9}, {
  3.7733905391550426`*^9, 3.773390609439636*^9}, {3.77339065731166*^9, 
  3.773390682446127*^9}, {3.773390893916485*^9, 3.773390896378539*^9}, {
  3.7733909396810503`*^9, 3.773391207005361*^9}, {3.7733912692483377`*^9, 
  3.7733913490850153`*^9}, {3.773391402567938*^9, 3.7733914027095413`*^9}, {
  3.77339148264685*^9, 
  3.773391484367972*^9}},ExpressionUUID->"af622ba1-2ceb-4e69-8920-\
c50b13cf32e9"],

Cell[CellGroupData[{

Cell["Exercise 1", "Section",
 CellChangeTimes->{{3.773390294770686*^9, 
  3.773390304605698*^9}},ExpressionUUID->"93f63236-ea90-4841-aa5f-\
31b1185ac7e9"],

Cell[TextData[{
 "Consider a simple example of two parallel links with cost functions ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["c", "1"], "(", "x", ")"}], "=", 
    SuperscriptBox["x", "2"]}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "c928b3a4-a982-4831-a0c4-9f735c590c06"],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["c", "2"], "(", "x", ")"}], "=", 
    RowBox[{"x", "+", "1"}]}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "bd4e037d-01d3-40d4-8913-f9900d3817f3"],
 ".\nDefine these two functions.\nDefine a function, that a vector of flow \
values (i.e. a list {x1, x2}) and outputs a vector of costs on the edges \
induced by the above cost functions.\nDefine a function that checks whether \
the input flow vector is a Wardrop Equilibrium wrt. to the above cost \
functions. ",
 StyleBox["Hint: ",
  FontSlant->"Italic"],
 "Use If and && and || or the AND and OR function."
}], "Text",
 CellChangeTimes->{{3.773391521125218*^9, 3.773391638808683*^9}, {
  3.7733916943167553`*^9, 3.773391791753846*^9}, {3.773392013932632*^9, 
  3.773392051541828*^9}, {3.773392388876439*^9, 3.773392396345387*^9}, {
  3.7733938039872923`*^9, 
  3.773393812736014*^9}},ExpressionUUID->"459cad9f-a6f5-4273-8177-\
57861e4efa44"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"c1", "[", "x_", "]"}], 
  RowBox[{"(*", " ", 
   RowBox[{"...", "."}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c2", "[", "x_", "]"}], 
  RowBox[{"(*", " ", 
   RowBox[{"...", "."}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cost", "[", "x_", "]"}], 
  RowBox[{"(*", " ", 
   RowBox[{"...", "."}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"isequilibrium", "[", "x_", "]"}]}], "Input",
 CellChangeTimes->{{3.773390697674306*^9, 3.773390725694104*^9}, {
  3.773390798091372*^9, 3.7733908873935328`*^9}, {3.7733915829698687`*^9, 
  3.7733915854263153`*^9}, {3.773391797234864*^9, 3.773391840230085*^9}, {
  3.773392418710375*^9, 
  3.773392450109439*^9}},ExpressionUUID->"0699b858-8d8d-4f3d-88b8-\
8f3976e33cb9"],

Cell[CellGroupData[{

Cell["Solution", "Subsection",
 CellChangeTimes->{{3.7733918995068903`*^9, 
  3.773391907539626*^9}},ExpressionUUID->"98a67fac-a0bb-4853-9a68-\
03ff5dd67eca"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"c1", "[", "x_", "]"}], ":=", 
  RowBox[{"x", "^", "2"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c2", "[", "x_", "]"}], ":=", 
  RowBox[{"x", "+", "1"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cost", "[", "x_", "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"c1", "[", 
     RowBox[{"x", "[", 
      RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
    RowBox[{"c2", "[", 
     RowBox[{"x", "[", 
      RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"isequilibrium", "[", "x_", "]"}], ":=", 
   RowBox[{"If", "[", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"x", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "0"}], " ", "||", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"cost", "[", "x", "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
         RowBox[{"Min", "[", 
          RowBox[{"cost", "[", "x", "]"}], "]"}]}]}], ")"}], " ", "&&", " ", 
      RowBox[{"(", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"x", "[", 
          RowBox[{"[", "2", "]"}], "]"}], " ", "\[Equal]", " ", "0"}], " ", "||",
         " ", 
        RowBox[{
         RowBox[{
          RowBox[{"cost", "[", "x", "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
         RowBox[{"Min", "[", 
          RowBox[{"cost", "[", "x", "]"}], "]"}]}]}], ")"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{
      "x", ",", "\"\< is a Wardrop Equilibrium with cost \>\"", ",", " ", 
       RowBox[{"cost", "[", "x", "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{
      "x", ",", "\"\< is not a Wardrop Equilibrium (Cost \>\"", ",", " ", 
       RowBox[{"cost", "[", "x", "]"}], ",", " ", "\"\<)\>\""}], "]"}]}], 
    "]"}]}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Tests", " ", "for", " ", "diffent", " ", "flows"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"cost", "[", 
  RowBox[{"{", 
   RowBox[{"2", ",", "3"}], "}"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"isequilibrium", "[", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], "]"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Tests", " ", "for", " ", "diffent", " ", "flows"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"cost", "[", 
  RowBox[{"{", 
   RowBox[{"1", ",", "0"}], "}"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"isequilibrium", "[", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], "]"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Tests", " ", "for", " ", "diffent", " ", "flows"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"cost", "[", 
  RowBox[{"{", 
   RowBox[{"2", ",", "2"}], "}"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"isequilibrium", "[", 
  RowBox[{"{", 
   RowBox[{"2", ",", "2"}], "}"}], "]"}]}], "Input",
 CellChangeTimes->{{3.7733919103588047`*^9, 3.773391998879674*^9}, {
  3.773392058123837*^9, 3.773392126119336*^9}, {3.7733921632674713`*^9, 
  3.773392232589189*^9}, {3.773392281949473*^9, 3.773392330106924*^9}, {
  3.773392366368807*^9, 3.773392375118734*^9}},
 CellLabel->
  "In[257]:=",ExpressionUUID->"17794bf3-f9f8-4f38-b011-8e75eada16e7"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"4", ",", "4"}], "}"}]], "Output",
 CellChangeTimes->{
  3.7733921924826117`*^9, 3.773392233101283*^9, 3.7733923313554163`*^9, {
   3.7733923695074472`*^9, 3.7733924014823723`*^9}},
 CellLabel->
  "Out[261]=",ExpressionUUID->"abcfd967-618e-4a2f-97f3-da3a651dee7a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], 
   "\[InvisibleSpace]", "\<\" is a Wardrop Equilibrium with cost \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"4", ",", "4"}], "}"}]}],
  SequenceForm[{2, 3}, " is a Wardrop Equilibrium with cost ", {4, 4}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.773392331374045*^9, {3.773392369518195*^9, 3.773392401503646*^9}},
 CellLabel->
  "During evaluation of \
In[257]:=",ExpressionUUID->"5d6060c7-fc5c-4b2a-b915-0c2718e4173c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{
  3.7733921924826117`*^9, 3.773392233101283*^9, 3.7733923313554163`*^9, {
   3.7733923695074472`*^9, 3.7733924015097647`*^9}},
 CellLabel->
  "Out[263]=",ExpressionUUID->"cfd0abe8-8586-40e8-9e2c-ddf3f5c168ff"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], 
   "\[InvisibleSpace]", "\<\" is a Wardrop Equilibrium with cost \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}],
  SequenceForm[{1, 0}, " is a Wardrop Equilibrium with cost ", {1, 1}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.773392331374045*^9, {3.773392369518195*^9, 3.773392401513534*^9}},
 CellLabel->
  "During evaluation of \
In[257]:=",ExpressionUUID->"9c45bbf2-1f6d-4070-8b22-870015ddcfed"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"4", ",", "3"}], "}"}]], "Output",
 CellChangeTimes->{
  3.7733921924826117`*^9, 3.773392233101283*^9, 3.7733923313554163`*^9, {
   3.7733923695074472`*^9, 3.773392401517604*^9}},
 CellLabel->
  "Out[265]=",ExpressionUUID->"02250f15-887e-45cb-816e-95fa56f09e62"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}], 
   "\[InvisibleSpace]", "\<\" is not a Wardrop Equilibrium (Cost \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"4", ",", "3"}], "}"}], "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm[{2, 2}, " is not a Wardrop Equilibrium (Cost ", {4, 3}, ")"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.773392331374045*^9, {3.773392369518195*^9, 3.773392401520982*^9}},
 CellLabel->
  "During evaluation of \
In[257]:=",ExpressionUUID->"de8baf71-b045-4bd7-a953-3127a1a49a56"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Exercise 2", "Section",
 CellChangeTimes->{{3.773392465886229*^9, 3.773392475318151*^9}, {
  3.7733948216604433`*^9, 
  3.773394825357975*^9}},ExpressionUUID->"9df04e44-e6f2-489a-8cd5-\
f232bb9c258b"],

Cell[TextData[{
 "Now consider ",
 Cell[BoxData[
  FormBox["m", TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "52c0feb6-9343-48af-a8a6-8404c4ecce66"],
 " edges with affine cost functions ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["c", "i"], "(", "x", ")"}], "=", 
    RowBox[{
     RowBox[{
      SubscriptBox["a", "i"], "x"}], "+", 
     SubscriptBox["b", "i"]}]}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "743a04f2-4c57-4521-bdcd-9c8f4ab20316"],
 ". Assume that the coefficients of these functions are given as lists a and \
b. Write functions similar to Exercise 1 for this case.\n",
 StyleBox["Hint: ",
  FontSlant->"Italic"],
 "To check the equilibrium conditions, you may first create a list using \
Table[] or Array[] containing for every edge TRUE if the edge satisfies the \
WE conditions (i.e., if ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["x", "e"], "=", "0"}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "ccdb193a-0455-4104-bfe9-dc6a194d8a96"],
 " or ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["c", "e"], "(", 
     SubscriptBox["x", "e"], ")"}], "=", 
    RowBox[{
     SubscriptBox["min", "j"], " ", 
     RowBox[{
      SubscriptBox["c", "j"], "(", 
      SubscriptBox["x", "j"], ")"}]}]}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "fd2d5685-5047-4e0b-b15d-33877d2c71c4"],
 "). Then you can use the AND function and apply it to the list (using \
Apply[And, (list)] or And@@list)."
}], "Text",
 CellChangeTimes->{{3.773392496474752*^9, 3.773392592525363*^9}, {
  3.773393406707673*^9, 
  3.773393610425839*^9}},ExpressionUUID->"e3795335-486e-4a63-9557-\
dc851d83954b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Example", " ", "coefficients", " ", "given", " ", "as", " ", "lists"}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"a", "=", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1", ",", "3"}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"b", "=", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "3", ",", "2"}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Determine", " ", "number", " ", "of", " ", "edges", " ", "depending", 
     " ", "on", " ", "number", " ", "of", " ", "coefficients", " ", "given"}],
     " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"m", "=", 
     RowBox[{"Length", "[", "a", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Wanted", " ", 
     RowBox[{"Functions", " ", "--"}], " ", "the", " ", "cost", " ", 
     "functions", " ", "depend", " ", "on", " ", "the", " ", "index", " ", 
     "of", " ", "the", " ", "edge", " ", "e", " ", "and", " ", "the", " ", 
     "flow", " ", "x"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"c", "[", 
    RowBox[{"e_", ",", "x_"}], "]"}], 
   RowBox[{"(*", " ", 
    RowBox[{"...", "."}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"cost", "[", "x_", "]"}], 
   RowBox[{"(*", " ", 
    RowBox[{"...", "."}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"isequilibrium", "[", "x_", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.773392595361444*^9, 3.773392701280469*^9}, {
  3.773392737283296*^9, 3.7733927389458237`*^9}, {3.773392811859622*^9, 
  3.7733928274732857`*^9}, {3.773393376750731*^9, 
  3.773393394996922*^9}},ExpressionUUID->"9d47f384-51e1-46fd-8da4-\
bc4ad4e8e164"],

Cell[CellGroupData[{

Cell["Solution", "Subsection",
 CellChangeTimes->{{3.773392650712922*^9, 
  3.773392657568771*^9}},ExpressionUUID->"638c47f8-f3a4-4ba8-96b5-\
1fdaa133bc8e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Example", " ", "coefficients", " ", "given", " ", "as", " ", "lists"}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"a", "=", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1", ",", "3"}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"b", "=", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "3", ",", "2"}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Determine", " ", "number", " ", "of", " ", "edges", " ", "depending", 
     " ", "on", " ", "number", " ", "of", " ", "coefficients", " ", "given"}],
     " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"m", "=", 
     RowBox[{"Length", "[", "a", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Wanted", " ", "Functions"}], " ", "*)"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{"c", "[", 
     RowBox[{"e_", ",", "x_"}], "]"}], ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"a", "[", 
       RowBox[{"[", "e", "]"}], "]"}], "*", "x"}], "+", 
     RowBox[{"b", "[", 
      RowBox[{"[", "e", "]"}], "]"}]}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"cost", "[", "x_", "]"}], ":=", 
    RowBox[{"Table", "[", " ", 
     RowBox[{
      RowBox[{"c", "[", 
       RowBox[{"e", ",", 
        RowBox[{"x", "[", 
         RowBox[{"[", "e", "]"}], "]"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"e", ",", "1", ",", "m"}], "}"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"isequilibrium", "[", "x_", "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"And", "@@", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"x", "[", 
              RowBox[{"[", "e", "]"}], "]"}], "\[Equal]", "0"}], "||", 
            RowBox[{
             RowBox[{
              RowBox[{"cost", "[", "x", "]"}], "[", 
              RowBox[{"[", "e", "]"}], "]"}], "\[Equal]", 
             RowBox[{"Min", "[", 
              RowBox[{"cost", "[", "x", "]"}], "]"}]}]}], ")"}], ",", 
          RowBox[{"{", 
           RowBox[{"e", ",", "1", ",", "m"}], "}"}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Print", "[", 
        RowBox[{"x", ",", "\"\< is a WE with costs \>\"", ",", 
         RowBox[{"cost", "[", "x", "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Print", "[", 
        RowBox[{"x", ",", "\"\< is not a WE (costs \>\"", ",", 
         RowBox[{"cost", "[", "x", "]"}], ",", " ", "\"\<)\>\""}], "]"}]}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Tests", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"isequilibrium", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"isequilibrium", "[", 
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", "0", ",", 
      RowBox[{"1", "/", "3"}]}], "}"}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"isequilibrium", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3", ",", "0"}], "}"}], "]"}]}]}]], "Input",
 CellChangeTimes->{
  3.77339270796198*^9, {3.773392741027215*^9, 3.773392849804154*^9}, {
   3.773392893960896*^9, 3.7733929353693533`*^9}, {3.773392986990531*^9, 
   3.77339333500028*^9}},
 CellLabel->
  "In[353]:=",ExpressionUUID->"b2cf4aa2-61ed-4d5a-8fcc-92b2c46db7f4"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], 
   "\[InvisibleSpace]", "\<\" is a WE with costs \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "3", ",", "2"}], "}"}]}],
  SequenceForm[{1, 0, 0, 0}, " is a WE with costs ", {1, 1, 3, 2}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.77339328141197*^9, 3.773393335233037*^9}},
 CellLabel->
  "During evaluation of \
In[353]:=",ExpressionUUID->"a85b062b-1297-4c5d-8b24-4e6fe91ba900"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "1", ",", "0", ",", 
     FractionBox["1", "3"]}], "}"}], 
   "\[InvisibleSpace]", "\<\" is a WE with costs \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"3", ",", "3", ",", "3", ",", "3"}], "}"}]}],
  SequenceForm[{3, 1, 0, 
    Rational[1, 3]}, " is a WE with costs ", {3, 3, 3, 3}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.77339328141197*^9, 3.773393335241334*^9}},
 CellLabel->
  "During evaluation of \
In[353]:=",ExpressionUUID->"fe31c77c-dfb1-44b7-82ac-847269a7d4ad"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3", ",", "0"}], "}"}], 
   "\[InvisibleSpace]", "\<\" is not a WE (costs \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"1", ",", "5", ",", "6", ",", "2"}], "}"}], 
   "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm[{1, 2, 3, 0}, " is not a WE (costs ", {1, 5, 6, 2}, ")"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.77339328141197*^9, 3.773393335249167*^9}},
 CellLabel->
  "During evaluation of \
In[353]:=",ExpressionUUID->"a7a8c5ba-3c67-4069-96ac-4bedaa9eb8c4"]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Exercise 3", "Section",
 CellChangeTimes->{{3.7733936360443287`*^9, 
  3.77339364255247*^9}},ExpressionUUID->"ddceb16b-8625-4ae1-89c9-\
485949fb38cc"],

Cell[TextData[{
 "Given cost functions ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["c", "e"], "(", "x", ")"}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "263478b7-5da7-4c3d-8175-74dc56673ab8"],
 " the modified cost functions ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox[
      OverscriptBox["c", "~"], "e"], "(", "x", ")"}], ":=", 
    RowBox[{
     RowBox[{
      SubscriptBox["c", "e"], "(", "x", ")"}], "+", 
     RowBox[{"x", " ", 
      SubscriptBox[
       RowBox[{"c", "'"}], "e"], 
      RowBox[{"(", "x", ")"}]}]}]}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "3d9e4fdb-c113-4f81-864f-4f19c74653d2"],
 " are called ",
 StyleBox["marginal cost functions. ",
  FontSlant->"Italic"],
 "A Wardrop equilibrium with respect to the marginal cost is a ",
 StyleBox["optimal flow",
  FontSlant->"Italic"],
 ", i.e., a flow that minimizes the total cost ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["\[Sum]", "e"], 
    RowBox[{
     SubscriptBox["x", "e"], 
     RowBox[{
      SubscriptBox["c", "e"], "(", 
      SubscriptBox["x", "e"], ")"}]}]}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "b20df9e8-42b5-4102-aee2-255b3ebcf50a"],
 ". \nAssume given cost functions c[e_, x_]. Define a function cmarg[e_, x_] \
that computes the marginal cost of edge e at x using c[e_, x_e]. \n",
 StyleBox["Hint: ",
  FontSlant->"Italic"],
 "You can use the function D[ f , x ] that computes the derivative of the \
expression f wrt to x. Given a function f, you can create the derivative \
function as follows g[x_]:= ( D[f[y], y] ) /.y->x. (This computes the \
derivative of f[y] wrt to y and then plugs in the function argument x for y. \
See also rules in the next session).\nFurther, define a function, that given \
a flow x computes the total cost of that flow. (Use the cost function from \
Ex. 2 and the function Total)."
}], "Text",
 CellChangeTimes->{{3.773393956560425*^9, 3.773394008437669*^9}, {
  3.773394047280155*^9, 3.773394304603187*^9}, {3.773394367437169*^9, 
  3.773394390722456*^9}, {3.773394447626055*^9, 
  3.773394681022047*^9}},ExpressionUUID->"5a0f31b5-515b-48e6-89d7-\
7c279f77f475"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"cmarg", "[", 
   RowBox[{"e_", ",", "x_"}], "]"}], 
  RowBox[{"(*", " ", "...", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"totalcost", "[", "x_", "]"}]}], "Input",
 CellChangeTimes->{{3.773394682596911*^9, 
  3.773394716064*^9}},ExpressionUUID->"e1d78b11-5d5f-48c2-8371-b52df7d2e445"],

Cell[CellGroupData[{

Cell["Solution", "Subsection",
 CellChangeTimes->{{3.773394718914453*^9, 
  3.773394726012074*^9}},ExpressionUUID->"987cd846-5292-42bb-b2b0-\
f95183e7fd6a"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"cmarg", "[", 
   RowBox[{"e_", ",", "x_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"c", "[", 
    RowBox[{"e", ",", "x"}], "]"}], "+", 
   RowBox[{
    RowBox[{"x", "[", 
     RowBox[{"[", "e", "]"}], "]"}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"D", "[", 
       RowBox[{
        RowBox[{"c", "[", 
         RowBox[{"e", ",", "\[Xi]"}], "]"}], ",", "\[Xi]"}], "]"}], "/.", 
      RowBox[{"\[Xi]", "\[Rule]", "x"}]}], ")"}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"totalcost", "[", "x_", "]"}], ":=", 
  RowBox[{"Total", "[", 
   RowBox[{"cost", "[", "x", "]"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.773394736991014*^9, 
  3.773394801126053*^9}},ExpressionUUID->"ab3dd9b6-a475-49ce-a647-\
bc0596104ef5"]
}, Open  ]]
}, Closed]]
}, Open  ]]
},
WindowSize->{879, 857},
WindowMargins->{{Automatic, 80}, {0, Automatic}},
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 166, 3, 98, "Title",ExpressionUUID->"b468e586-f10e-4d47-a7bf-19a2822df633"],
Cell[749, 27, 6669, 168, 280, "Text",ExpressionUUID->"af622ba1-2ceb-4e69-8920-c50b13cf32e9"],
Cell[CellGroupData[{
Cell[7443, 199, 155, 3, 67, "Section",ExpressionUUID->"93f63236-ea90-4841-aa5f-31b1185ac7e9"],
Cell[7601, 204, 1336, 33, 150, "Text",ExpressionUUID->"459cad9f-a6f5-4273-8177-57861e4efa44"],
Cell[8940, 239, 789, 19, 94, "Input",ExpressionUUID->"0699b858-8d8d-4f3d-88b8-8f3976e33cb9"],
Cell[CellGroupData[{
Cell[9754, 262, 158, 3, 54, "Subsection",ExpressionUUID->"98a67fac-a0bb-4853-9a68-03ff5dd67eca"],
Cell[CellGroupData[{
Cell[9937, 269, 3344, 90, 367, "Input",ExpressionUUID->"17794bf3-f9f8-4f38-b011-8e75eada16e7"],
Cell[13284, 361, 303, 7, 34, "Output",ExpressionUUID->"abcfd967-618e-4a2f-97f3-da3a651dee7a"],
Cell[13590, 370, 550, 15, 24, "Print",ExpressionUUID->"5d6060c7-fc5c-4b2a-b915-0c2718e4173c"],
Cell[14143, 387, 303, 7, 34, "Output",ExpressionUUID->"cfd0abe8-8586-40e8-9e2c-ddf3f5c168ff"],
Cell[14449, 396, 550, 15, 24, "Print",ExpressionUUID->"9c45bbf2-1f6d-4070-8b22-870015ddcfed"],
Cell[15002, 413, 301, 7, 34, "Output",ExpressionUUID->"02250f15-887e-45cb-816e-95fa56f09e62"],
Cell[15306, 422, 589, 15, 24, "Print",ExpressionUUID->"de8baf71-b045-4bd7-a953-3127a1a49a56"]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[15956, 444, 206, 4, 53, "Section",ExpressionUUID->"9df04e44-e6f2-489a-8cd5-f232bb9c258b"],
Cell[16165, 450, 1766, 51, 130, "Text",ExpressionUUID->"e3795335-486e-4a63-9557-dc851d83954b"],
Cell[17934, 503, 1764, 43, 199, "Input",ExpressionUUID->"9d47f384-51e1-46fd-8da4-bc4ad4e8e164"],
Cell[CellGroupData[{
Cell[19723, 550, 156, 3, 54, "Subsection",ExpressionUUID->"638c47f8-f3a4-4ba8-96b5-1fdaa133bc8e"],
Cell[CellGroupData[{
Cell[19904, 557, 3527, 94, 367, "Input",ExpressionUUID->"b2cf4aa2-61ed-4d5a-8fcc-92b2c46db7f4"],
Cell[CellGroupData[{
Cell[23456, 655, 540, 13, 24, "Print",ExpressionUUID->"a85b062b-1297-4c5d-8b24-4e6fe91ba900"],
Cell[23999, 670, 582, 15, 40, "Print",ExpressionUUID->"fe31c77c-dfb1-44b7-82ac-847269a7d4ad"],
Cell[24584, 687, 583, 14, 24, "Print",ExpressionUUID->"a7a8c5ba-3c67-4069-96ac-4bedaa9eb8c4"]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[25240, 709, 156, 3, 53, "Section",ExpressionUUID->"ddceb16b-8625-4ae1-89c9-485949fb38cc"],
Cell[25399, 714, 2234, 58, 242, "Text",ExpressionUUID->"5a0f31b5-515b-48e6-89d7-7c279f77f475"],
Cell[27636, 774, 326, 7, 52, "Input",ExpressionUUID->"e1d78b11-5d5f-48c2-8371-b52df7d2e445"],
Cell[CellGroupData[{
Cell[27987, 785, 156, 3, 54, "Subsection",ExpressionUUID->"987cd846-5292-42bb-b2b0-f95183e7fd6a"],
Cell[28146, 790, 766, 23, 52, "Input",ExpressionUUID->"ab3dd9b6-a475-49ce-a647-bc0596104ef5"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}
]
*)

