(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     91145,       2445]
NotebookOptionsPosition[     86222,       2355]
NotebookOutlinePosition[     86577,       2371]
CellTagsIndexPosition[     86534,       2368]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Session 2 : Exercises", "Title",
 CellChangeTimes->{{3.7734633534067583`*^9, 
  3.773463360160838*^9}},ExpressionUUID->"22bb18d6-3bff-48c5-914b-\
2bd61693100a"],

Cell[CellGroupData[{

Cell["Exercise 1", "Section",
 CellChangeTimes->{{3.77346350421033*^9, 
  3.773463507426774*^9}},ExpressionUUID->"f2ef0afa-17d8-4ec7-8ecf-\
02d073926434"],

Cell[TextData[{
 "Given three parallel edges with cost functions ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["c", "1"], "(", "x", ")"}], "=", 
    RowBox[{
     SuperscriptBox["x", "2"], "+", "x"}]}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "42d34c2e-5370-4e0b-bbb3-b60825ceb873"],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["c", "2"], "(", "x", ")"}], "=", 
    RowBox[{
     SuperscriptBox["x", "4"], "+", 
     SuperscriptBox["x", "2"]}]}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "e996a54f-e442-40df-b302-87ba235d7b18"],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["c", "3"], "(", "x", ")"}], "=", 
    RowBox[{"x", "+", "1"}]}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "24c6112f-ea36-42f5-9f45-e1367bcc5437"],
 ", compute a Wardrop Equilibrium for demand rate ",
 Cell[BoxData[
  FormBox[
   RowBox[{"r", "=", "5"}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "93bd1a83-5fff-4094-83c5-a0d35f936d8a"],
 "."
}], "Text",
 CellChangeTimes->{{3.773463621103388*^9, 3.773463657833804*^9}, {
  3.7734637770448103`*^9, 3.773463826027749*^9}, {3.7734639643075333`*^9, 
  3.773463972110251*^9}, {3.773464131844921*^9, 
  3.773464131955698*^9}},ExpressionUUID->"a6fcca75-e153-4671-9169-\
8a943d8fdbcd"],

Cell[BoxData[
 RowBox[{"Solve", "[", " ", 
  RowBox[{"(*", " ", "...", " ", "*)"}], " ", "]"}]], "Input",
 CellChangeTimes->{{3.773463660784045*^9, 3.773463758539061*^9}, {
  3.773463846835216*^9, 3.773463953479981*^9}, {3.773463999835002*^9, 
  3.7734639999877443`*^9}, {3.773464031760737*^9, 
  3.7734640377424192`*^9}},ExpressionUUID->"1c5fa787-7f4b-4848-b9f9-\
064325cecb7d"],

Cell[CellGroupData[{

Cell["Solution", "Subsection",
 CellChangeTimes->{{3.773463988818061*^9, 
  3.7734639948888597`*^9}},ExpressionUUID->"d7cb5b48-e50f-41b0-ae3e-\
b41cef5ed637"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"x", "^", "2"}], "+", "x"}], "\[Equal]", 
      RowBox[{
       RowBox[{"y", "^", "4"}], "+", 
       RowBox[{"y", "^", "2"}]}]}], ",", 
     RowBox[{
      RowBox[{"y", "^", "2"}], "\[Equal]", 
      RowBox[{"z", "+", "1"}]}], ",", 
     RowBox[{
      RowBox[{"x", "+", "y", "+", "z"}], "\[Equal]", "5"}], ",", " ", 
     RowBox[{"x", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{"y", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{"z", "\[GreaterEqual]", "0"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7734640099532137`*^9, 3.773464018888891*^9}},
 CellLabel->"In[26]:=",ExpressionUUID->"64ca70d0-56b7-4757-8af5-32bbab6c7cca"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"x", "\[Rule]", 
     FractionBox["9", "4"]}], ",", 
    RowBox[{"y", "\[Rule]", 
     FractionBox["3", "2"]}], ",", 
    RowBox[{"z", "\[Rule]", 
     FractionBox["5", "4"]}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.773464019474955*^9},
 CellLabel->"Out[26]=",ExpressionUUID->"b3c840b5-1bf2-4da9-9634-6db9e61dde04"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Exercise 2", "Section",
 CellChangeTimes->{{3.773464058040608*^9, 
  3.773464061047227*^9}},ExpressionUUID->"ca4085cb-8e8c-4fa8-894c-\
993bbfe3149e"],

Cell[TextData[{
 "We want to write a function that computes an equilibrium for two parallel \
links with affine cost functions in dependence of the demand rate ",
 Cell[BoxData[
  FormBox["r", TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "a61907a7-c0d3-44e9-9c9e-a0dcb2bd38ce"],
 "."
}], "Text",
 CellChangeTimes->{{3.773464240774556*^9, 3.773464258139995*^9}, {
  3.773464687578657*^9, 3.7734647249059772`*^9}, {3.773464806212246*^9, 
  3.773464825279635*^9}, {3.773464920814871*^9, 
  3.7734649215681458`*^9}},ExpressionUUID->"4abb765c-eb82-404f-b74e-\
e1c1b13762ed"],

Cell[CellGroupData[{

Cell["a)", "Subsection",
 CellChangeTimes->{{3.77346492308527*^9, 
  3.773464924761714*^9}},ExpressionUUID->"f09edce7-5496-4fb3-932e-\
94296d70349f"],

Cell[TextData[{
 "Compute the solution by solving ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["c", "1"], "(", "x", ")"}], "=", 
     RowBox[{
      SubscriptBox["c", "2"], "(", "y", ")"}]}], ",", " ", 
    RowBox[{
     RowBox[{"x", "+", "y"}], "=", "r"}]}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "4a67b0fc-d424-4a04-8500-928d49ae137d"],
 " for x and y. This yields solutions that may be negative. Write a function \
that cuts off negative flows and flows greater than the demand (i.e. \
something like ",
 Cell[BoxData[
  FormBox[
   RowBox[{"max", "(", 
    RowBox[{"0", ",", 
     RowBox[{"min", "(", 
      RowBox[{"r", ",", "x"}], ")"}]}], ")"}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "d869d280-2cd0-4fef-a11d-a6f7b387a15f"],
 ") and apply it to the solution.\nYou may want to use the function \
PiecewiseExpand[ ] and apply it to the solution to get a nice, piecewise \
representation of the function. "
}], "Text",
 CellChangeTimes->{{3.773464930065899*^9, 3.773465167110811*^9}, {
  3.773465361151547*^9, 3.7734653620964193`*^9}, {3.773465583071706*^9, 
  3.773465583294613*^9}},ExpressionUUID->"6faeeca3-d70e-4f05-8589-\
4c2ea45bd20d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Some", " ", "example", " ", "cost", " ", "functions"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"c1", "[", "x_", "]"}], ":=", 
     RowBox[{"x", "+", "1"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"c2", "[", "x_", "]"}], ":=", 
    RowBox[{"2", "x"}]}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Solve", " ", "the", " ", "system"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"sol", "=", 
     RowBox[{"First", "[", 
      RowBox[{"Solve", "[", 
       RowBox[{"(*", "...", "*)"}], "]"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"flows", " ", "=", " ", 
    RowBox[{"(*", " ", "...", " ", "*)"}], " ", 
    RowBox[{
    "/.", " ", "sol", "\[IndentingNewLine]", 
     "\[IndentingNewLine]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.773464260664263*^9, 3.773464472525532*^9}, 
   3.773464640533668*^9, {3.773464748671954*^9, 3.773464759457156*^9}, {
   3.7734651753377743`*^9, 3.773465461603582*^9}, {3.773465492926661*^9, 
   3.773465502980641*^9}, {3.773465534235243*^9, 
   3.7734655503204412`*^9}},ExpressionUUID->"81a9d7f9-6326-4469-b0b7-\
5f9d09930953"],

Cell[TextData[{
 "The solution for the given Example function should be\n",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    TagBox[GridBox[{
       {"\[Piecewise]", GridBox[{
          {
           RowBox[{
            FractionBox["1", "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", " ", "r"}]}], ")"}]}], 
           RowBox[{"r", ">", 
            FractionBox["1", "2"]}]},
          {"0", 
           TagBox["True",
            "PiecewiseDefault",
            AutoDelete->True]}
         },
         AllowedDimensions->{2, Automatic},
         Editable->True,
         GridBoxAlignment->{
          "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{1.}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.84]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}},
         Selectable->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{
       "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.35]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "Piecewise",
     DeleteWithContents->True,
     Editable->False,
     SelectWithContents->True,
     Selectable->False], ",", 
    TagBox[GridBox[{
       {"\[Piecewise]", GridBox[{
          {"r", 
           RowBox[{"0", "<", "r", "\[LessEqual]", 
            FractionBox["1", "2"]}]},
          {
           FractionBox[
            RowBox[{"1", "+", "r"}], "3"], 
           RowBox[{"r", ">", 
            FractionBox["1", "2"]}]},
          {"0", 
           TagBox["True",
            "PiecewiseDefault",
            AutoDelete->True]}
         },
         AllowedDimensions->{2, Automatic},
         Editable->True,
         GridBoxAlignment->{
          "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{1.}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.84]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}},
         Selectable->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{
       "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.35]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     "Piecewise",
     DeleteWithContents->True,
     Editable->False,
     SelectWithContents->True,
     Selectable->False]}], "}"}]],
  CellChangeTimes->{
   3.7734643005834723`*^9, {3.7734644467584476`*^9, 3.77346445772261*^9}, 
    3.773464641144677*^9, 3.773464760093417*^9, {3.773465368511714*^9, 
    3.773465421295843*^9}, {3.773465453220687*^9, 3.773465462081943*^9}},
  ExpressionUUID->"bfb91b94-4d16-4e55-91de-aaa9285349ab"]
}], "Text",
 CellChangeTimes->{{3.773465512546142*^9, 
  3.773465528080586*^9}},ExpressionUUID->"c3e1b9b0-8348-43be-840f-\
771bdbd34ce8"],

Cell[CellGroupData[{

Cell["Solution", "Subsubsection",
 CellChangeTimes->{{3.7734654711620703`*^9, 
  3.773465473218932*^9}},ExpressionUUID->"46bc72ce-5132-41bd-b032-\
15366068e614"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Some", " ", "example", " ", "cost", " ", "functions"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"c1", "[", "x_", "]"}], ":=", 
     RowBox[{"x", "+", "1"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"c2", "[", "x_", "]"}], ":=", 
    RowBox[{"2", "x"}]}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Solve", " ", "the", " ", "system"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"sol", "=", 
     RowBox[{"First", "[", 
      RowBox[{"Solve", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"c1", "[", "f1", "]"}], "\[Equal]", 
         RowBox[{"c2", "[", 
          RowBox[{"r", "-", "f1"}], "]"}]}], ",", "f1"}], "]"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
     "Create", " ", "a", " ", "solution", " ", "vector", " ", "containing", 
      " ", "the", " ", "flows", " ", "x1"}], ",", " ", "x2"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"flows", "=", 
     RowBox[{"FullSimplify", "[", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"f1", ",", 
          RowBox[{"r", "-", "f1"}]}], "}"}], "/.", "sol"}], ")"}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
     "Cut", " ", "off", " ", "negative", " ", "flows", " ", "and", " ", 
      "flows"}], " ", ">", " ", "r"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"Max", "[", 
         RowBox[{"0", ",", 
          RowBox[{"Min", "[", 
           RowBox[{"r", ",", "#"}], "]"}]}], "]"}], ")"}], "&"}], "  ", 
      "--"}], "-", " ", 
     RowBox[{
     "this", " ", "creates", " ", "an", " ", "anonymous", " ", "function", 
      " ", "where", " ", "#", " ", "represents", " ", "the", " ", 
      RowBox[{"variable", " ", "\[IndentingNewLine]", "/@", " ", 
       RowBox[{"--", 
        RowBox[{"-", " ", "Applies"}]}]}], " ", "the", " ", "preceding", " ", 
      "function", " ", "componentwise", " ", "to", " ", "the", " ", 
      "vector"}]}], "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"flows", "=", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"Max", "[", 
         RowBox[{"0", ",", 
          RowBox[{"Min", "[", 
           RowBox[{"r", ",", "#"}], "]"}]}], "]"}], ")"}], "&"}], "/@", 
      "flows"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Creates", " ", "a", " ", "simplified"}], ",", " ", 
     RowBox[{"piecewise", " ", "function"}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"FullSimplify", "[", 
    RowBox[{"PiecewiseExpand", "/@", "flows"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.773464260664263*^9, 3.773464472525532*^9}, 
   3.773464640533668*^9, {3.773464748671954*^9, 3.773464759457156*^9}, {
   3.7734651753377743`*^9, 3.773465461603582*^9}},
 CellLabel->"In[91]:=",ExpressionUUID->"25f9af4a-a94d-43d0-974e-b5b42e48ec46"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          RowBox[{
           FractionBox["1", "3"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             RowBox[{"2", " ", "r"}]}], ")"}]}], 
          RowBox[{"r", ">", 
           FractionBox["1", "2"]}]},
         {"0", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False], ",", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {"r", 
          RowBox[{"0", "<", "r", "\[LessEqual]", 
           FractionBox["1", "2"]}]},
         {
          FractionBox[
           RowBox[{"1", "+", "r"}], "3"], 
          RowBox[{"r", ">", 
           FractionBox["1", "2"]}]},
         {"0", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False]}], "}"}]], "Output",
 CellChangeTimes->{
  3.7734643005834723`*^9, {3.7734644467584476`*^9, 3.77346445772261*^9}, 
   3.773464641144677*^9, 3.773464760093417*^9, {3.773465368511714*^9, 
   3.773465421295843*^9}, {3.773465453220687*^9, 3.773465462081943*^9}},
 CellLabel->"Out[96]=",ExpressionUUID->"c6182e7c-c347-42d5-bdd5-f3985ecfe9bc"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["b)", "Subsection",
 CellChangeTimes->{{3.773465597385964*^9, 
  3.773465600619884*^9}},ExpressionUUID->"24bf82b0-7a3e-4d7d-be53-\
157be564460e"],

Cell["\<\
In order to use the same code to compute the equilibrium flows and the \
optimal flows (which can be obtained by computing an equilibrium wrt. \
marginal costs), we want to write a function that carries out the code from \
part a).
To do this, we use the Module[ ] function. This functions creates a scope for \
local variables and used as follows.\
\>", "Text",
 CellChangeTimes->{{3.773465626812551*^9, 3.773465725123322*^9}, {
  3.77346576093253*^9, 3.773465781542243*^9}, {3.773465852453047*^9, 
  3.773465860663578*^9}, {3.773465993652299*^9, 3.77346605460246*^9}, {
  3.7734661377179003`*^9, 
  3.773466141227961*^9}},ExpressionUUID->"a53b5021-3eee-4036-a4b6-\
1445bb6ed99a"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"globalvar", "=", "42"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f", "[", "x0_", "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Define", " ", "a", " ", "module", " ", "with", " ", "local", " ", 
     "variables", " ", "x", " ", "and", " ", 
     RowBox[{"y", ".", " ", "x"}], " ", "is", " ", "initialized", " ", "with",
      " ", "x0"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"Module", "[", " ", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"x", "=", "x0"}], ",", "y"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "scope", " ", "for", " ", "the", " ", "local", " ", "code", " ", 
       "begins"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{"some", " ", "random", " ", "computations"}], "..."}], " ", 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"x", ">", "1"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"y", "=", 
          RowBox[{"x", "^", "2"}]}], ";"}], "\[IndentingNewLine]", ",", 
        "\[IndentingNewLine]", 
        RowBox[{"y", "=", 
         RowBox[{"-", "x"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Global", " ", "variables", " ", "can", " ", "be", " ", "used"}], " ", 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"y", "=", 
       RowBox[{"y", "+", "x", "+", "globalvar"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{"A", " ", "line", " ", "without"}], " ", ";", " ", 
        RowBox[{
        "determines", " ", "the", " ", "returned", " ", "value", " ", "of", 
         " ", "the", " ", 
         RowBox[{"module", ".", "\[IndentingNewLine]", "You"}], " ", "can", 
         " ", "also", " ", "use", " ", "the", " ", "function", " ", 
         RowBox[{"Return", "[", " ", "...", " ", "]"}]}]}], " ", "*)"}], 
      "\[IndentingNewLine]", "y"}]}], "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{"End", " ", "of", " ", "the", " ", "module"}], " ", "*)"}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.7734660566773653`*^9, 3.773466057055086*^9}, {
  3.773466094844795*^9, 
  3.773466416708757*^9}},ExpressionUUID->"dd3cbfa7-4763-49c1-9ab4-\
64ef70cf9fd2"],

Cell[TextData[{
 "Use the code from a) to create a function that computes the equilibrium \
depending on the two cost functions ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["c", "1"], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "2da72ac6-7d36-46c3-9169-e95aad5efbe4"],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["c", "2"], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "21210a2b-9bb6-475c-b93f-1ac26e1374a2"],
 ". The test code should return the same result as in a)."
}], "Text",
 CellChangeTimes->{{3.773466438557407*^9, 3.773466478076475*^9}, {
  3.773466619072692*^9, 
  3.773466629276477*^9}},ExpressionUUID->"6ae6574e-f93c-443a-81d9-\
70c88126df61"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"equilibrium", "[", 
     RowBox[{"cf1_", ",", "cf2_"}], "]"}], ":=", 
    RowBox[{"Module", "[", " ", 
     RowBox[{
      RowBox[{"{", " ", 
       RowBox[{"(*", 
        RowBox[{"local", " ", "vars"}], " ", "*)"}], " ", "}"}], ","}], " ", 
     RowBox[{"(*", " ", "code", " ", "*)"}], " ", "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", "Test", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"c1", "[", "x_", "]"}], ":=", 
   RowBox[{"x", "+", "1"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c2", "[", "x_", "]"}], ":=", 
  RowBox[{"2", "x"}]}], "\[IndentingNewLine]", 
 RowBox[{"equilibrium", "[", 
  RowBox[{"c1", ",", " ", "c2"}], "]"}]}], "Input",
 CellChangeTimes->{{3.773466456815173*^9, 3.773466518430208*^9}, {
  3.773466616138413*^9, 
  3.7734666164762077`*^9}},ExpressionUUID->"db5fc243-83ad-490e-b50a-\
2de877d0a895"],

Cell[CellGroupData[{

Cell["Solution", "Subsubsection",
 CellChangeTimes->{{3.7734665212727137`*^9, 
  3.773466523983815*^9}},ExpressionUUID->"ff7858b3-06b9-464b-a284-\
d2b5c1a046e7"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"equilibrium", "[", 
     RowBox[{"cf1_", ",", "cf2_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"c1", "=", "cf1"}], ",", 
        RowBox[{"c2", "=", "cf2"}], ",", "flows", ",", "sol"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"sol", "=", 
        RowBox[{"First", "[", 
         RowBox[{"Solve", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"c1", "[", "f1", "]"}], "\[Equal]", 
            RowBox[{"c2", "[", 
             RowBox[{"r", "-", "f1"}], "]"}]}], ",", "f1"}], "]"}], "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{
         "Create", " ", "a", " ", "solution", " ", "vector", " ", 
          "containing", " ", "the", " ", "flows", " ", "x1"}], ",", " ", 
         "x2"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"flows", "=", 
        RowBox[{"FullSimplify", "[", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"f1", ",", 
             RowBox[{"r", "-", "f1"}]}], "}"}], "/.", "sol"}], ")"}], "]"}]}],
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{
         "Cut", " ", "off", " ", "negative", " ", "flows", " ", "and", " ", 
          "flows"}], " ", ">", " ", "r"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"Max", "[", 
             RowBox[{"0", ",", 
              RowBox[{"Min", "[", 
               RowBox[{"r", ",", "#"}], "]"}]}], "]"}], ")"}], "&"}], "  ", 
          "--"}], "-", " ", 
         RowBox[{
         "this", " ", "creates", " ", "an", " ", "anonymous", " ", "function",
           " ", "where", " ", "#", " ", "represents", " ", "the", " ", 
          RowBox[{"variable", " ", "\[IndentingNewLine]", "/@", " ", 
           RowBox[{"--", 
            RowBox[{"-", " ", "Applies"}]}]}], " ", "the", " ", "preceding", 
          " ", "function", " ", "componentwise", " ", "to", " ", "the", " ", 
          "vector"}]}], "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
       
       RowBox[{"flows", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"Max", "[", 
            RowBox[{"0", ",", 
             RowBox[{"Min", "[", 
              RowBox[{"r", ",", "#"}], "]"}]}], "]"}], ")"}], "&"}], "/@", 
         "flows"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{"Creates", " ", "a", " ", "simplified"}], ",", " ", 
         RowBox[{
         "piecewise", " ", "function", " ", "and", " ", "returns", " ", 
          "it"}]}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"Return", "[", 
        RowBox[{"FullSimplify", "[", 
         RowBox[{"PiecewiseExpand", "/@", "flows"}], "]"}], "]"}], ";"}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", "Test", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"c1", "[", "x_", "]"}], ":=", 
   RowBox[{"x", "+", "1"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"c2", "[", "x_", "]"}], ":=", 
  RowBox[{"2", "x"}]}], "\[IndentingNewLine]", 
 RowBox[{"equilibrium", "[", 
  RowBox[{"c1", ",", " ", "c2"}], "]"}]}], "Input",
 CellChangeTimes->{{3.7734665361867943`*^9, 3.773466606598322*^9}},
 CellLabel->"In[97]:=",ExpressionUUID->"702c64a3-ff06-4568-bfe7-2613fa7f9a16"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          RowBox[{
           FractionBox["1", "3"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             RowBox[{"2", " ", "r"}]}], ")"}]}], 
          RowBox[{"r", ">", 
           FractionBox["1", "2"]}]},
         {"0", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False], ",", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {"r", 
          RowBox[{"0", "<", "r", "\[LessEqual]", 
           FractionBox["1", "2"]}]},
         {
          FractionBox[
           RowBox[{"1", "+", "r"}], "3"], 
          RowBox[{"r", ">", 
           FractionBox["1", "2"]}]},
         {"0", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False]}], "}"}]], "Output",
 CellChangeTimes->{3.7734666073274927`*^9},
 CellLabel->
  "Out[100]=",ExpressionUUID->"f9073933-399b-46b6-954b-e11f2d3a4391"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Exercise 3", "Section",
 CellChangeTimes->{{3.773466632946106*^9, 
  3.7734666447862377`*^9}},ExpressionUUID->"76532c63-634c-4633-9ef4-\
d4071d1b6cca"],

Cell[TextData[{
 "Now create a notebook that, after input of two (affine linear) cost \
functions ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["c", "1"], ",", 
    SubscriptBox["c", "2"]}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "0371eb9f-7fbc-4fa2-a65d-35c9adca08d3"],
 ", computes the 1) equilibrium flow with its total cost 2) the optimal flow \
with its cost and 3) the price of anarchy function, which is \
cost(equilibrium)/cost(optimal flow).\nEntering the cost functions"
}], "Text",
 CellChangeTimes->{{3.773466922973658*^9, 
  3.7734670823261957`*^9}},ExpressionUUID->"4f5b72d7-ea49-44d0-add3-\
267a22248da1"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"c1", "[", "x_", "]"}], ":=", 
   RowBox[{"x", "+", "1"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"c2", "[", "x_", "]"}], ":=", 
  RowBox[{"2", "x"}]}]}], "Input",
 CellChangeTimes->{{3.77346708315022*^9, 
  3.773467083152218*^9}},ExpressionUUID->"97d6366b-99e6-49b3-b44b-\
89e876d4aa9f"],

Cell["\<\
and then executing your code should return the following solution\
\>", "Text",
 CellChangeTimes->{{3.773467084285768*^9, 
  3.773467112239663*^9}},ExpressionUUID->"94c0344d-208d-43f7-a1cb-\
944f8d0ea271"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Equilbrium Flows: x1=\"\>", "\[InvisibleSpace]", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          RowBox[{
           FractionBox["1", "3"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             RowBox[{"2", " ", "r"}]}], ")"}]}], 
          RowBox[{"r", ">", 
           FractionBox["1", "2"]}]},
         {"0", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False], "\[InvisibleSpace]", "\<\"   x2 = \"\>", 
   "\[InvisibleSpace]", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {"r", 
          RowBox[{"0", "<", "r", "\[LessEqual]", 
           FractionBox["1", "2"]}]},
         {
          FractionBox[
           RowBox[{"1", "+", "r"}], "3"], 
          RowBox[{"r", ">", 
           FractionBox["1", "2"]}]},
         {"0", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False]}],
  SequenceForm["Equilbrium Flows: x1=", 
   Piecewise[{{
     Rational[1, 3] (-1 + 2 $CellContext`r), $CellContext`r > 
      Rational[1, 2]}}, 0], "   x2 = ", 
   Piecewise[{{$CellContext`r, 
      Inequality[0, Less, $CellContext`r, LessEqual, 
       Rational[1, 2]]}, {
     Rational[1, 3] (1 + $CellContext`r), $CellContext`r > Rational[1, 2]}}, 
    0]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.773305307942649*^9, 3.7733055612325974`*^9, {3.773305606232235*^9, 
   3.773305617450603*^9}, 3.7733056537774687`*^9, {3.773305780070381*^9, 
   3.773305802827052*^9}, 3.773305836120926*^9, {3.773305870794581*^9, 
   3.773305876263274*^9}, 3.773305934971759*^9, {3.773306006806007*^9, 
   3.7733060280012712`*^9}, {3.773306080631977*^9, 3.7733060896891327`*^9}, {
   3.773306143932482*^9, 3.773306172933935*^9}, 3.773306487656041*^9, 
   3.773306550102831*^9, 3.773306591711768*^9, {3.7733066685138683`*^9, 
   3.7733066871128693`*^9}, 3.773306816865838*^9, 3.773307201232874*^9, 
   3.7734668587960997`*^9},
 CellLabel->
  "During evaluation of \
In[104]:=",ExpressionUUID->"7b54fd73-0a82-4a86-8910-810a7547c48c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Equilibrium Cost: \"\>", "\[InvisibleSpace]", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          RowBox[{"2", " ", 
           SuperscriptBox["r", "2"]}], 
          RowBox[{"0", "<", "r", "\[LessEqual]", 
           FractionBox["1", "2"]}]},
         {
          RowBox[{
           FractionBox["2", "3"], " ", "r", " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", "r"}], ")"}]}], 
          RowBox[{
           RowBox[{"2", " ", "r"}], ">", "1"}]},
         {"0", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False]}],
  SequenceForm["Equilibrium Cost: ", 
   Piecewise[{{2 $CellContext`r^2, 
      Inequality[0, Less, $CellContext`r, LessEqual, 
       Rational[1, 2]]}, {
     Rational[2, 3] $CellContext`r (1 + $CellContext`r), 2 $CellContext`r > 
      1}}, 0]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.773305307942649*^9, 3.7733055612325974`*^9, {3.773305606232235*^9, 
   3.773305617450603*^9}, 3.7733056537774687`*^9, {3.773305780070381*^9, 
   3.773305802827052*^9}, 3.773305836120926*^9, {3.773305870794581*^9, 
   3.773305876263274*^9}, 3.773305934971759*^9, {3.773306006806007*^9, 
   3.7733060280012712`*^9}, {3.773306080631977*^9, 3.7733060896891327`*^9}, {
   3.773306143932482*^9, 3.773306172933935*^9}, 3.773306487656041*^9, 
   3.773306550102831*^9, 3.773306591711768*^9, {3.7733066685138683`*^9, 
   3.7733066871128693`*^9}, 3.773306816865838*^9, 3.773307201232874*^9, 
   3.7734668588095493`*^9},
 CellLabel->
  "During evaluation of \
In[104]:=",ExpressionUUID->"e685eda4-61cd-4040-8f18-22283e6be1bf"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Optimal Flows: xOpt1=\"\>", "\[InvisibleSpace]", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          RowBox[{
           FractionBox["1", "6"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             RowBox[{"4", " ", "r"}]}], ")"}]}], 
          RowBox[{"r", ">", 
           FractionBox["1", "4"]}]},
         {"0", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False], "\[InvisibleSpace]", "\<\"   x2 = \"\>", 
   "\[InvisibleSpace]", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {"r", 
          RowBox[{"0", "<", "r", "\[LessEqual]", 
           FractionBox["1", "4"]}]},
         {
          RowBox[{
           FractionBox["1", "6"], " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             RowBox[{"2", " ", "r"}]}], ")"}]}], 
          RowBox[{"r", ">", 
           FractionBox["1", "4"]}]},
         {"0", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False]}],
  SequenceForm["Optimal Flows: xOpt1=", 
   Piecewise[{{
     Rational[1, 6] (-1 + 4 $CellContext`r), $CellContext`r > 
      Rational[1, 4]}}, 0], "   x2 = ", 
   Piecewise[{{$CellContext`r, 
      Inequality[0, Less, $CellContext`r, LessEqual, 
       Rational[1, 4]]}, {
     Rational[1, 6] (1 + 2 $CellContext`r), $CellContext`r > Rational[1, 4]}},
     0]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.773305307942649*^9, 3.7733055612325974`*^9, {3.773305606232235*^9, 
   3.773305617450603*^9}, 3.7733056537774687`*^9, {3.773305780070381*^9, 
   3.773305802827052*^9}, 3.773305836120926*^9, {3.773305870794581*^9, 
   3.773305876263274*^9}, 3.773305934971759*^9, {3.773306006806007*^9, 
   3.7733060280012712`*^9}, {3.773306080631977*^9, 3.7733060896891327`*^9}, {
   3.773306143932482*^9, 3.773306172933935*^9}, 3.773306487656041*^9, 
   3.773306550102831*^9, 3.773306591711768*^9, {3.7733066685138683`*^9, 
   3.7733066871128693`*^9}, 3.773306816865838*^9, 3.773307201232874*^9, 
   3.773466858821184*^9},
 CellLabel->
  "During evaluation of \
In[104]:=",ExpressionUUID->"53db2899-c715-4250-9a07-18a69cbdda4a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Optimal Cost: \"\>", "\[InvisibleSpace]", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          RowBox[{"2", " ", 
           SuperscriptBox["r", "2"]}], 
          RowBox[{"0", "<", "r", "\[LessEqual]", 
           FractionBox["1", "4"]}]},
         {
          RowBox[{
           FractionBox["1", "12"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             RowBox[{"8", " ", "r"}], "+", 
             RowBox[{"8", " ", 
              SuperscriptBox["r", "2"]}]}], ")"}]}], 
          RowBox[{
           RowBox[{"4", " ", "r"}], ">", "1"}]},
         {"0", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False]}],
  SequenceForm["Optimal Cost: ", 
   Piecewise[{{2 $CellContext`r^2, 
      Inequality[0, Less, $CellContext`r, LessEqual, 
       Rational[1, 4]]}, {
     Rational[1, 12] (-1 + 8 $CellContext`r + 8 $CellContext`r^2), 
      4 $CellContext`r > 1}}, 0]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.773305307942649*^9, 3.7733055612325974`*^9, {3.773305606232235*^9, 
   3.773305617450603*^9}, 3.7733056537774687`*^9, {3.773305780070381*^9, 
   3.773305802827052*^9}, 3.773305836120926*^9, {3.773305870794581*^9, 
   3.773305876263274*^9}, 3.773305934971759*^9, {3.773306006806007*^9, 
   3.7733060280012712`*^9}, {3.773306080631977*^9, 3.7733060896891327`*^9}, {
   3.773306143932482*^9, 3.773306172933935*^9}, 3.773306487656041*^9, 
   3.773306550102831*^9, 3.773306591711768*^9, {3.7733066685138683`*^9, 
   3.7733066871128693`*^9}, 3.773306816865838*^9, 3.773307201232874*^9, 
   3.7734668588291473`*^9},
 CellLabel->
  "During evaluation of \
In[104]:=",ExpressionUUID->"4cff7483-8559-44ba-99bc-a11b6a03b8a3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Price of Anarchy: \"\>", "\[InvisibleSpace]", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {"1", 
          RowBox[{"r", "\[LessEqual]", 
           FractionBox["1", "4"]}]},
         {
          FractionBox[
           RowBox[{"24", " ", 
            SuperscriptBox["r", "2"]}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            RowBox[{"8", " ", "r"}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["r", "2"]}]}]], 
          RowBox[{
           FractionBox["1", "4"], "<", "r", "\[LessEqual]", 
           FractionBox["1", "2"]}]},
         {
          FractionBox[
           RowBox[{"8", " ", "r", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", "r"}], ")"}]}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            RowBox[{"8", " ", "r"}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["r", "2"]}]}]], 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False]}],
  SequenceForm["Price of Anarchy: ", 
   Piecewise[{{1, $CellContext`r <= Rational[1, 4]}, {
     24 $CellContext`r^2/(-1 + 8 $CellContext`r + 8 $CellContext`r^2), 
      Inequality[
       Rational[1, 4], Less, $CellContext`r, LessEqual, 
       Rational[1, 2]]}}, 8 $CellContext`r (1 + $CellContext`r)/(-1 + 
    8 $CellContext`r + 8 $CellContext`r^2)]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.773305307942649*^9, 3.7733055612325974`*^9, {3.773305606232235*^9, 
   3.773305617450603*^9}, 3.7733056537774687`*^9, {3.773305780070381*^9, 
   3.773305802827052*^9}, 3.773305836120926*^9, {3.773305870794581*^9, 
   3.773305876263274*^9}, 3.773305934971759*^9, {3.773306006806007*^9, 
   3.7733060280012712`*^9}, {3.773306080631977*^9, 3.7733060896891327`*^9}, {
   3.773306143932482*^9, 3.773306172933935*^9}, 3.773306487656041*^9, 
   3.773306550102831*^9, 3.773306591711768*^9, {3.7733066685138683`*^9, 
   3.7733066871128693`*^9}, 3.773306816865838*^9, 3.773307201232874*^9, 
   3.773466858885683*^9},
 CellLabel->
  "During evaluation of \
In[104]:=",ExpressionUUID->"6b6ac1aa-2a3a-420b-8a87-c7e38b69a21f"]
}, Open  ]],

Cell["\<\
(you might need to apply PiecewiseExpand and Simplify to your solutions)\
\>", "Text",
 CellChangeTimes->{{3.773467130531098*^9, 
  3.773467157307239*^9}},ExpressionUUID->"891cffc5-7870-46d2-90ee-\
2835afcd357c"],

Cell[CellGroupData[{

Cell["Solution", "Subsection",
 CellChangeTimes->{{3.7734671700149717`*^9, 
  3.773467176103065*^9}},ExpressionUUID->"919b0efe-95aa-46df-8f94-\
d434da63aebf"],

Cell[CellGroupData[{

Cell["Compute Equilibrium and Optimal Flows", "Subsubsection",
 CellChangeTimes->{{3.773304644100787*^9, 
  3.773304660971717*^9}},ExpressionUUID->"f058ef0a-a1a1-4a45-bc5f-\
bb7f75034789"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Cost", " ", "function", " ", "input"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"c1", "[", "x_", "]"}], ":=", 
     RowBox[{"x", "+", "1"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"c2", "[", "x_", "]"}], ":=", 
    RowBox[{"2", "x"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
     "Define", " ", "a", " ", "functions", " ", "\"\<equilibrium\>\"", " ", 
      "depending", " ", "on", " ", "cost", " ", "functions", " ", "cf1"}], 
     ",", " ", 
     RowBox[{
     "cf2", " ", "that", " ", "computes", " ", "a", " ", "Wardrop", " ", 
      "Equilibrium", " ", "for", " ", "two", " ", "parallel", " ", "links", 
      " ", "with", " ", "these", " ", "cost", " ", "functions"}]}], " ", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"equilibrium", "[", 
      RowBox[{"cf1_", ",", "cf2_"}], "]"}], ":=", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{
       "Define", " ", "a", " ", "Module", " ", "with", " ", "local", " ", 
        "variables", " ", "c1"}], ",", " ", 
       RowBox[{
        RowBox[{
        "c2", " ", "that", " ", "are", " ", "initialized", " ", "with", " ", 
         "the", " ", "arguments", " ", "of", " ", "the", " ", 
         "\"\<equilibrium\>\""}], "-", "function"}]}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"c1", "=", "cf1"}], ",", 
         RowBox[{"c2", "=", "cf2"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "Solve", " ", "the", " ", "equilibrium", " ", "conditions", " ", 
         "and", " ", "take", " ", "the", " ", "first", " ", "solution", " ", 
         RowBox[{"(", 
          RowBox[{
          "assuming", " ", "that", " ", "there", " ", "is", " ", "a", " ", 
           "unique", " ", "solution"}], ")"}]}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"sol", "=", 
         RowBox[{
          RowBox[{"Solve", "[", " ", 
           RowBox[{
            RowBox[{
             RowBox[{"c1", "[", "f1", "]"}], " ", "\[Equal]", " ", 
             RowBox[{"c2", "[", 
              RowBox[{"r", "-", "f1"}], "]"}]}], ",", " ", "f1"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
          "Create", " ", "a", " ", "list", " ", "of", " ", "the", " ", "two", 
           " ", "flows", " ", "on", " ", "both", " ", "edges", " ", 
           RowBox[{"(", 
            RowBox[{"f1", ",", " ", "f2"}], ")"}], " ", "where", " ", "f2"}], 
          " ", "=", " ", 
          RowBox[{"r", " ", "-", " ", 
           RowBox[{
            RowBox[{"f1", ".", " ", "Plug"}], " ", "in", " ", "the", " ", 
            "solution", " ", "computed", " ", "above"}]}]}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"flows", "=", 
         RowBox[{"FullSimplify", "[", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"f1", ",", 
              RowBox[{"r", "-", "f1"}]}], "}"}], "/.", "sol"}], ")"}], 
          "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
          "Cut", " ", "off", " ", "negative", " ", "flows", " ", "and", " ", 
           "flows"}], " ", ">", " ", "r"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"flows", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"Max", "[", 
             RowBox[{"0", ",", 
              RowBox[{"Min", "[", 
               RowBox[{"r", ",", "#"}], "]"}]}], "]"}], ")"}], "&"}], "/@", 
          "flows"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "Return", " ", "the", " ", "resulting", " ", "flow", " ", "vector"}],
          " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Return", "[", 
         RowBox[{"FullSimplify", "[", 
          RowBox[{"PiecewiseExpand", "/@", "flows"}], "]"}], "]"}], ";"}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Call", " ", "the", " ", "\"\<equilibrium\>\"", " ", "function", " ", 
     "with", " ", "normal", " ", "cost", " ", "functions"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"eqflows", "=", 
     RowBox[{"equilibrium", "[", 
      RowBox[{"c1", ",", "c2"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Equilbrium Flows: x1=\>\"", ",", " ", 
      RowBox[{"eqflows", "[", 
       RowBox[{"[", "1", "]"}], "]"}], ",", " ", "\"\<   x2 = \>\"", ",", 
      RowBox[{"eqflows", "[", 
       RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
     "Compute", " ", "the", " ", "total", " ", "cost", " ", "of", " ", "the", 
      " ", "Equilibrium", " ", "solution", " ", "as", " ", 
      SubscriptBox["x", "1"], 
      SubscriptBox["c", "1"], 
      RowBox[{"(", 
       SubscriptBox["x", "1"], ")"}]}], " ", "+", " ", 
     RowBox[{
      SubscriptBox["x", "2"], 
      SubscriptBox["c", "2"], 
      RowBox[{"(", 
       SubscriptBox["x", "2"], ")"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{"eqcost", " ", "=", " ", 
     RowBox[{"Simplify", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"flows", "[", 
         RowBox[{"[", "1", "]"}], "]"}], "*", 
        RowBox[{"c1", "[", 
         RowBox[{"flows", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "+", 
       RowBox[{
        RowBox[{"flows", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "*", 
        RowBox[{"c2", "[", 
         RowBox[{"flows", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "]"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Print", "[", 
    RowBox[{"\"\<Equilibrium Cost: \>\"", ",", " ", "eqcost"}], "]"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
     "Compute", " ", "the", " ", "marginal", " ", "cost", " ", "as", " ", "c", 
      RowBox[{"(", "x", ")"}]}], " ", "+", " ", 
     RowBox[{"x", " ", 
      RowBox[{
       RowBox[{"c", "'"}], "[", "x", "]"}]}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"margc1", "[", "x_", "]"}], ":=", 
     RowBox[{
      RowBox[{"c1", "[", "x", "]"}], "+", 
      RowBox[{"x", "*", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"D", "[", 
          RowBox[{
           RowBox[{"c1", "[", "\[Xi]", "]"}], ",", "\[Xi]"}], "]"}], "/.", 
         RowBox[{"\[Xi]", "\[Rule]", "x"}]}], ")"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"margc2", "[", "x_", "]"}], ":=", 
     RowBox[{
      RowBox[{"c2", "[", "x", "]"}], "+", 
      RowBox[{"x", "*", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"D", "[", 
          RowBox[{
           RowBox[{"c2", "[", "\[Xi]", "]"}], ",", "\[Xi]"}], "]"}], "/.", 
         RowBox[{"\[Xi]", "\[Rule]", "x"}]}], ")"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Call", " ", "the", " ", "\"\<equilibrium\>\"", " ", "function", " ", 
     "with", " ", "normal", " ", "cost", " ", "functions"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"optflows", "=", 
     RowBox[{"equilibrium", "[", 
      RowBox[{"margc1", ",", "margc2"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Optimal Flows: xOpt1=\>\"", ",", " ", 
      RowBox[{"optflows", "[", 
       RowBox[{"[", "1", "]"}], "]"}], ",", " ", "\"\<   x2 = \>\"", ",", 
      RowBox[{"optflows", "[", 
       RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Compute", " ", "the", " ", "total", " ", "cost", " ", "of", " ", "the", 
     " ", "Equilibrium", " ", "solution"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"optcost", " ", "=", " ", 
     RowBox[{"Simplify", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"flows", "[", 
         RowBox[{"[", "1", "]"}], "]"}], "*", 
        RowBox[{"c1", "[", 
         RowBox[{"optflows", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "+", 
       RowBox[{
        RowBox[{"flows", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "*", 
        RowBox[{"c2", "[", 
         RowBox[{"optflows", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "]"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Print", "[", 
    RowBox[{"\"\<Optimal Cost: \>\"", ",", " ", "optcost"}], "]"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Compute", " ", "the", " ", "price", " ", "of", " ", "Anarchy"}], 
    " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Assumptions", " ", "are", " ", "only", " ", "needed", " ", "for", " ", 
     "parametrized", " ", "example"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"poa", "=", 
     RowBox[{"Simplify", "[", 
      RowBox[{
       RowBox[{"PiecewiseExpand", "[", 
        RowBox[{"Simplify", "[", 
         RowBox[{
          RowBox[{"eqcost", "/", "optcost"}], ",", " ", 
          RowBox[{"Assumptions", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"r", ">", "0"}], ",", 
             RowBox[{"a1", ">", "0"}], ",", 
             RowBox[{"a2", ">", "0"}], ",", 
             RowBox[{"b2", "\[GreaterEqual]", "b1"}], ",", 
             RowBox[{"b1", ">", "0"}]}], "}"}]}]}], "]"}], "]"}], ",", " ", 
       RowBox[{"Assumptions", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"r", ">", "0"}], ",", 
          RowBox[{"a1", ">", "0"}], ",", 
          RowBox[{"a2", ">", "0"}], ",", 
          RowBox[{"b2", "\[GreaterEqual]", "b1"}], ",", 
          RowBox[{"b1", ">", "0"}]}], "}"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Price of Anarchy: \>\"", ",", " ", "poa"}], "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Compute", " ", "the", " ", "maximal", " ", "price", " ", "of", " ", 
     "anarchy"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"poasol", "=", 
     RowBox[{"Maximize", "[", 
      RowBox[{"poa", ",", "r"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Maximal PoA is \>\"", ",", " ", 
      RowBox[{"poasol", "[", 
       RowBox[{"[", "1", "]"}], "]"}], ",", " ", "\"\< at r=\>\"", ",", " ", 
      RowBox[{"r", "/.", 
       RowBox[{"poasol", "[", 
        RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ";"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.773304676477211*^9, 3.77330484499564*^9}, {
  3.773304976760281*^9, 3.773304997665237*^9}, {3.773305054173315*^9, 
  3.773305371604611*^9}, {3.773305408332458*^9, 3.773305411370348*^9}, {
  3.773305444450941*^9, 3.773305704324106*^9}, {3.773305737276524*^9, 
  3.773305870473145*^9}, {3.77330602504289*^9, 3.773306027426635*^9}, {
  3.773306124304823*^9, 3.773306158475779*^9}, {3.7733062467318087`*^9, 
  3.77330626149514*^9}, {3.773306508713476*^9, 3.773306523029635*^9}, {
  3.773306588077138*^9, 3.7733065910206823`*^9}, {3.773306660388955*^9, 
  3.77330668655933*^9}, {3.773306899124107*^9, 3.7733070465190287`*^9}, {
  3.77346720609359*^9, 3.773467216546891*^9}},
 CellLabel->
  "In[119]:=",ExpressionUUID->"71944c1b-c3db-4264-8885-ba7b1bbcab30"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Equilbrium Flows: x1=\"\>", "\[InvisibleSpace]", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          RowBox[{
           FractionBox["1", "3"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             RowBox[{"2", " ", "r"}]}], ")"}]}], 
          RowBox[{"r", ">", 
           FractionBox["1", "2"]}]},
         {"0", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False], "\[InvisibleSpace]", "\<\"   x2 = \"\>", 
   "\[InvisibleSpace]", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {"r", 
          RowBox[{"0", "<", "r", "\[LessEqual]", 
           FractionBox["1", "2"]}]},
         {
          FractionBox[
           RowBox[{"1", "+", "r"}], "3"], 
          RowBox[{"r", ">", 
           FractionBox["1", "2"]}]},
         {"0", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False]}],
  SequenceForm["Equilbrium Flows: x1=", 
   Piecewise[{{
     Rational[1, 3] (-1 + 2 $CellContext`r), $CellContext`r > 
      Rational[1, 2]}}, 0], "   x2 = ", 
   Piecewise[{{$CellContext`r, 
      Inequality[0, Less, $CellContext`r, LessEqual, 
       Rational[1, 2]]}, {
     Rational[1, 3] (1 + $CellContext`r), $CellContext`r > Rational[1, 2]}}, 
    0]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.773305307942649*^9, 3.7733055612325974`*^9, {3.773305606232235*^9, 
   3.773305617450603*^9}, 3.7733056537774687`*^9, {3.773305780070381*^9, 
   3.773305802827052*^9}, 3.773305836120926*^9, {3.773305870794581*^9, 
   3.773305876263274*^9}, 3.773305934971759*^9, {3.773306006806007*^9, 
   3.7733060280012712`*^9}, {3.773306080631977*^9, 3.7733060896891327`*^9}, {
   3.773306143932482*^9, 3.773306172933935*^9}, 3.773306487656041*^9, 
   3.773306550102831*^9, 3.773306591711768*^9, {3.7733066685138683`*^9, 
   3.7733066871128693`*^9}, 3.773306816865838*^9, 3.773307201232874*^9, 
   3.7734668587960997`*^9, 3.773467217325732*^9},
 CellLabel->
  "During evaluation of \
In[119]:=",ExpressionUUID->"7764478e-f19d-4cfe-b6b3-be11419d5f03"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Equilibrium Cost: \"\>", "\[InvisibleSpace]", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          RowBox[{"2", " ", 
           SuperscriptBox["r", "2"]}], 
          RowBox[{"0", "<", "r", "\[LessEqual]", 
           FractionBox["1", "2"]}]},
         {
          RowBox[{
           FractionBox["2", "3"], " ", "r", " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", "r"}], ")"}]}], 
          RowBox[{
           RowBox[{"2", " ", "r"}], ">", "1"}]},
         {"0", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False]}],
  SequenceForm["Equilibrium Cost: ", 
   Piecewise[{{2 $CellContext`r^2, 
      Inequality[0, Less, $CellContext`r, LessEqual, 
       Rational[1, 2]]}, {
     Rational[2, 3] $CellContext`r (1 + $CellContext`r), 2 $CellContext`r > 
      1}}, 0]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.773305307942649*^9, 3.7733055612325974`*^9, {3.773305606232235*^9, 
   3.773305617450603*^9}, 3.7733056537774687`*^9, {3.773305780070381*^9, 
   3.773305802827052*^9}, 3.773305836120926*^9, {3.773305870794581*^9, 
   3.773305876263274*^9}, 3.773305934971759*^9, {3.773306006806007*^9, 
   3.7733060280012712`*^9}, {3.773306080631977*^9, 3.7733060896891327`*^9}, {
   3.773306143932482*^9, 3.773306172933935*^9}, 3.773306487656041*^9, 
   3.773306550102831*^9, 3.773306591711768*^9, {3.7733066685138683`*^9, 
   3.7733066871128693`*^9}, 3.773306816865838*^9, 3.773307201232874*^9, 
   3.7734668587960997`*^9, 3.773467217336812*^9},
 CellLabel->
  "During evaluation of \
In[119]:=",ExpressionUUID->"dc069322-e4a9-4846-99d2-8a0f7ec29bbb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Optimal Flows: xOpt1=\"\>", "\[InvisibleSpace]", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          RowBox[{
           FractionBox["1", "6"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             RowBox[{"4", " ", "r"}]}], ")"}]}], 
          RowBox[{"r", ">", 
           FractionBox["1", "4"]}]},
         {"0", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False], "\[InvisibleSpace]", "\<\"   x2 = \"\>", 
   "\[InvisibleSpace]", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {"r", 
          RowBox[{"0", "<", "r", "\[LessEqual]", 
           FractionBox["1", "4"]}]},
         {
          RowBox[{
           FractionBox["1", "6"], " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             RowBox[{"2", " ", "r"}]}], ")"}]}], 
          RowBox[{"r", ">", 
           FractionBox["1", "4"]}]},
         {"0", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False]}],
  SequenceForm["Optimal Flows: xOpt1=", 
   Piecewise[{{
     Rational[1, 6] (-1 + 4 $CellContext`r), $CellContext`r > 
      Rational[1, 4]}}, 0], "   x2 = ", 
   Piecewise[{{$CellContext`r, 
      Inequality[0, Less, $CellContext`r, LessEqual, 
       Rational[1, 4]]}, {
     Rational[1, 6] (1 + 2 $CellContext`r), $CellContext`r > Rational[1, 4]}},
     0]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.773305307942649*^9, 3.7733055612325974`*^9, {3.773305606232235*^9, 
   3.773305617450603*^9}, 3.7733056537774687`*^9, {3.773305780070381*^9, 
   3.773305802827052*^9}, 3.773305836120926*^9, {3.773305870794581*^9, 
   3.773305876263274*^9}, 3.773305934971759*^9, {3.773306006806007*^9, 
   3.7733060280012712`*^9}, {3.773306080631977*^9, 3.7733060896891327`*^9}, {
   3.773306143932482*^9, 3.773306172933935*^9}, 3.773306487656041*^9, 
   3.773306550102831*^9, 3.773306591711768*^9, {3.7733066685138683`*^9, 
   3.7733066871128693`*^9}, 3.773306816865838*^9, 3.773307201232874*^9, 
   3.7734668587960997`*^9, 3.7734672173449078`*^9},
 CellLabel->
  "During evaluation of \
In[119]:=",ExpressionUUID->"9e0f8a6c-36e2-45c0-82cc-bf697b5b5b6c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Optimal Cost: \"\>", "\[InvisibleSpace]", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          RowBox[{"2", " ", 
           SuperscriptBox["r", "2"]}], 
          RowBox[{"0", "<", "r", "\[LessEqual]", 
           FractionBox["1", "4"]}]},
         {
          RowBox[{
           FractionBox["1", "12"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             RowBox[{"8", " ", "r"}], "+", 
             RowBox[{"8", " ", 
              SuperscriptBox["r", "2"]}]}], ")"}]}], 
          RowBox[{
           RowBox[{"4", " ", "r"}], ">", "1"}]},
         {"0", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False]}],
  SequenceForm["Optimal Cost: ", 
   Piecewise[{{2 $CellContext`r^2, 
      Inequality[0, Less, $CellContext`r, LessEqual, 
       Rational[1, 4]]}, {
     Rational[1, 12] (-1 + 8 $CellContext`r + 8 $CellContext`r^2), 
      4 $CellContext`r > 1}}, 0]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.773305307942649*^9, 3.7733055612325974`*^9, {3.773305606232235*^9, 
   3.773305617450603*^9}, 3.7733056537774687`*^9, {3.773305780070381*^9, 
   3.773305802827052*^9}, 3.773305836120926*^9, {3.773305870794581*^9, 
   3.773305876263274*^9}, 3.773305934971759*^9, {3.773306006806007*^9, 
   3.7733060280012712`*^9}, {3.773306080631977*^9, 3.7733060896891327`*^9}, {
   3.773306143932482*^9, 3.773306172933935*^9}, 3.773306487656041*^9, 
   3.773306550102831*^9, 3.773306591711768*^9, {3.7733066685138683`*^9, 
   3.7733066871128693`*^9}, 3.773306816865838*^9, 3.773307201232874*^9, 
   3.7734668587960997`*^9, 3.773467217350613*^9},
 CellLabel->
  "During evaluation of \
In[119]:=",ExpressionUUID->"b1bfc369-886e-4af3-b0b0-d1c66828a282"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Price of Anarchy: \"\>", "\[InvisibleSpace]", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {"1", 
          RowBox[{"r", "\[LessEqual]", 
           FractionBox["1", "4"]}]},
         {
          FractionBox[
           RowBox[{"24", " ", 
            SuperscriptBox["r", "2"]}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            RowBox[{"8", " ", "r"}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["r", "2"]}]}]], 
          RowBox[{
           FractionBox["1", "4"], "<", "r", "\[LessEqual]", 
           FractionBox["1", "2"]}]},
         {
          FractionBox[
           RowBox[{"8", " ", "r", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", "r"}], ")"}]}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            RowBox[{"8", " ", "r"}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["r", "2"]}]}]], 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False]}],
  SequenceForm["Price of Anarchy: ", 
   Piecewise[{{1, $CellContext`r <= Rational[1, 4]}, {
     24 $CellContext`r^2/(-1 + 8 $CellContext`r + 8 $CellContext`r^2), 
      Inequality[
       Rational[1, 4], Less, $CellContext`r, LessEqual, 
       Rational[1, 2]]}}, 8 $CellContext`r (1 + $CellContext`r)/(-1 + 
    8 $CellContext`r + 8 $CellContext`r^2)]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.773305307942649*^9, 3.7733055612325974`*^9, {3.773305606232235*^9, 
   3.773305617450603*^9}, 3.7733056537774687`*^9, {3.773305780070381*^9, 
   3.773305802827052*^9}, 3.773305836120926*^9, {3.773305870794581*^9, 
   3.773305876263274*^9}, 3.773305934971759*^9, {3.773306006806007*^9, 
   3.7733060280012712`*^9}, {3.773306080631977*^9, 3.7733060896891327`*^9}, {
   3.773306143932482*^9, 3.773306172933935*^9}, 3.773306487656041*^9, 
   3.773306550102831*^9, 3.773306591711768*^9, {3.7733066685138683`*^9, 
   3.7733066871128693`*^9}, 3.773306816865838*^9, 3.773307201232874*^9, 
   3.7734668587960997`*^9, 3.7734672173562803`*^9},
 CellLabel->
  "During evaluation of \
In[119]:=",ExpressionUUID->"1b1059f9-0056-41b8-bdab-acc4e2b59efc"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Maximal PoA is \"\>", "\[InvisibleSpace]", 
   FractionBox["6", "5"], "\[InvisibleSpace]", "\<\" at r=\"\>", 
   "\[InvisibleSpace]", 
   FractionBox["1", "2"]}],
  SequenceForm["Maximal PoA is ", 
   Rational[6, 5], " at r=", 
   Rational[1, 2]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.773305307942649*^9, 3.7733055612325974`*^9, {3.773305606232235*^9, 
   3.773305617450603*^9}, 3.7733056537774687`*^9, {3.773305780070381*^9, 
   3.773305802827052*^9}, 3.773305836120926*^9, {3.773305870794581*^9, 
   3.773305876263274*^9}, 3.773305934971759*^9, {3.773306006806007*^9, 
   3.7733060280012712`*^9}, {3.773306080631977*^9, 3.7733060896891327`*^9}, {
   3.773306143932482*^9, 3.773306172933935*^9}, 3.773306487656041*^9, 
   3.773306550102831*^9, 3.773306591711768*^9, {3.7733066685138683`*^9, 
   3.7733066871128693`*^9}, 3.773306816865838*^9, 3.773307201232874*^9, 
   3.7734668587960997`*^9, 3.773467217361917*^9},
 CellLabel->
  "During evaluation of \
In[119]:=",ExpressionUUID->"73992ff7-199e-4118-8bfa-aee8cacb99fa"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{808, 857},
WindowMargins->{{Automatic, 387}, {Automatic, 30}},
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 166, 3, 98, "Title",ExpressionUUID->"22bb18d6-3bff-48c5-914b-2bd61693100a"],
Cell[CellGroupData[{
Cell[771, 29, 154, 3, 67, "Section",ExpressionUUID->"f2ef0afa-17d8-4ec7-8ecf-02d073926434"],
Cell[928, 34, 1406, 43, 58, "Text",ExpressionUUID->"a6fcca75-e153-4671-9169-8a943d8fdbcd"],
Cell[2337, 79, 379, 7, 30, "Input",ExpressionUUID->"1c5fa787-7f4b-4848-b9f9-064325cecb7d"],
Cell[CellGroupData[{
Cell[2741, 90, 158, 3, 54, "Subsection",ExpressionUUID->"d7cb5b48-e50f-41b0-ae3e-b41cef5ed637"],
Cell[CellGroupData[{
Cell[2924, 97, 829, 22, 30, "Input",ExpressionUUID->"64ca70d0-56b7-4757-8af5-32bbab6c7cca"],
Cell[3756, 121, 393, 11, 50, "Output",ExpressionUUID->"b3c840b5-1bf2-4da9-9634-6db9e61dde04"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4210, 139, 155, 3, 67, "Section",ExpressionUUID->"ca4085cb-8e8c-4fa8-894c-993bbfe3149e"],
Cell[4368, 144, 594, 13, 58, "Text",ExpressionUUID->"4abb765c-eb82-404f-b74e-e1c1b13762ed"],
Cell[CellGroupData[{
Cell[4987, 161, 149, 3, 54, "Subsection",ExpressionUUID->"f09edce7-5496-4fb3-932e-94296d70349f"],
Cell[5139, 166, 1251, 32, 127, "Text",ExpressionUUID->"6faeeca3-d70e-4f05-8589-4c2ea45bd20d"],
Cell[6393, 200, 1236, 32, 178, "Input",ExpressionUUID->"81a9d7f9-6326-4469-b0b7-5f9d09930953"],
Cell[7632, 234, 4198, 114, 108, "Text",ExpressionUUID->"c3e1b9b0-8348-43be-840f-771bdbd34ce8"],
Cell[CellGroupData[{
Cell[11855, 352, 161, 3, 45, "Subsubsection",ExpressionUUID->"46bc72ce-5132-41bd-b032-15366068e614"],
Cell[CellGroupData[{
Cell[12041, 359, 3163, 84, 346, "Input",ExpressionUUID->"25f9af4a-a94d-43d0-974e-b5b42e48ec46"],
Cell[15207, 445, 3929, 110, 83, "Output",ExpressionUUID->"c6182e7c-c347-42d5-bdd5-f3985ecfe9bc"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[19197, 562, 150, 3, 54, "Subsection",ExpressionUUID->"24bf82b0-7a3e-4d7d-be53-157be564460e"],
Cell[19350, 567, 691, 13, 127, "Text",ExpressionUUID->"a53b5021-3eee-4036-a4b6-1445bb6ed99a"],
Cell[20044, 582, 2433, 59, 367, "Input",ExpressionUUID->"dd3cbfa7-4763-49c1-9ab4-64ef70cf9fd2"],
Cell[22480, 643, 714, 19, 58, "Text",ExpressionUUID->"6ae6574e-f93c-443a-81d9-70c88126df61"],
Cell[23197, 664, 968, 26, 136, "Input",ExpressionUUID->"db5fc243-83ad-490e-b50a-2de877d0a895"],
Cell[CellGroupData[{
Cell[24190, 694, 161, 3, 45, "Subsubsection",ExpressionUUID->"ff7858b3-06b9-464b-a284-d2b5c1a046e7"],
Cell[CellGroupData[{
Cell[24376, 701, 3642, 92, 409, "Input",ExpressionUUID->"702c64a3-ff06-4568-bfe7-2613fa7f9a16"],
Cell[28021, 795, 3739, 108, 83, "Output",ExpressionUUID->"f9073933-399b-46b6-954b-e11f2d3a4391"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[31833, 911, 157, 3, 67, "Section",ExpressionUUID->"76532c63-634c-4633-9ef4-d4071d1b6cca"],
Cell[31993, 916, 663, 16, 104, "Text",ExpressionUUID->"4f5b72d7-ea49-44d0-add3-267a22248da1"],
Cell[32659, 934, 332, 10, 52, "Input",ExpressionUUID->"97d6366b-99e6-49b3-b44b-89e876d4aa9f"],
Cell[32994, 946, 215, 5, 35, "Text",ExpressionUUID->"94c0344d-208d-43f7-a1cb-944f8d0ea271"],
Cell[CellGroupData[{
Cell[33234, 955, 4844, 129, 74, "Print",ExpressionUUID->"7b54fd73-0a82-4a86-8910-810a7547c48c"],
Cell[38081, 1086, 3016, 77, 74, "Print",ExpressionUUID->"e685eda4-61cd-4040-8f18-22283e6be1bf"],
Cell[41100, 1165, 4943, 132, 74, "Print",ExpressionUUID->"53db2899-c715-4250-9a07-18a69cbdda4a"],
Cell[46046, 1299, 3152, 81, 74, "Print",ExpressionUUID->"4cff7483-8559-44ba-99bc-a11b6a03b8a3"],
Cell[49201, 1382, 3538, 90, 88, "Print",ExpressionUUID->"6b6ac1aa-2a3a-420b-8a87-c7e38b69a21f"]
}, Open  ]],
Cell[52754, 1475, 222, 5, 35, "Text",ExpressionUUID->"891cffc5-7870-46d2-90ee-2835afcd357c"],
Cell[CellGroupData[{
Cell[53001, 1484, 158, 3, 54, "Subsection",ExpressionUUID->"919b0efe-95aa-46df-8f94-d434da63aebf"],
Cell[CellGroupData[{
Cell[53184, 1491, 188, 3, 45, "Subsubsection",ExpressionUUID->"f058ef0a-a1a1-4a45-bc5f-bb7f75034789"],
Cell[CellGroupData[{
Cell[53397, 1498, 12011, 304, 1291, "Input",ExpressionUUID->"71944c1b-c3db-4264-8885-ba7b1bbcab30"],
Cell[CellGroupData[{
Cell[65433, 1806, 4866, 129, 74, "Print",ExpressionUUID->"7764478e-f19d-4cfe-b6b3-be11419d5f03"],
Cell[70302, 1937, 3038, 77, 74, "Print",ExpressionUUID->"dc069322-e4a9-4846-99d2-8a0f7ec29bbb"],
Cell[73343, 2016, 4969, 132, 74, "Print",ExpressionUUID->"9e0f8a6c-36e2-45c0-82cc-bf697b5b5b6c"],
Cell[78315, 2150, 3174, 81, 74, "Print",ExpressionUUID->"b1bfc369-886e-4af3-b0b0-d1c66828a282"],
Cell[81492, 2233, 3564, 90, 88, "Print",ExpressionUUID->"1b1059f9-0056-41b8-bdab-acc4e2b59efc"],
Cell[85059, 2325, 1087, 22, 40, "Print",ExpressionUUID->"73992ff7-199e-4118-8bfa-aee8cacb99fa"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]]
}
]
*)

