(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     37185,       1023]
NotebookOptionsPosition[     34259,        965]
NotebookOutlinePosition[     34614,        981]
CellTagsIndexPosition[     34571,        978]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Session 5: Exercises", "Title",
 CellChangeTimes->{{3.773474666825165*^9, 3.773474671850533*^9}, 
   3.773476302215439*^9},ExpressionUUID->"52cb39b7-d154-47e4-bd39-\
4907ec58e3a0"],

Cell[CellGroupData[{

Cell["Exercise 1:", "Section",
 CellChangeTimes->{{3.7734746771132307`*^9, 
  3.77347468042682*^9}},ExpressionUUID->"6e889ae3-9d5b-48f9-83c8-\
a591e15c8a2b"],

Cell[TextData[{
 "Recall the Price of Anarchy function from Exercise 2.3. Use the Maximize \
function to find the worst case demand rate ",
 Cell[BoxData[
  FormBox[
   RowBox[{"r", "\[GreaterEqual]", "0"}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "bfa4e415-443a-48d7-9b61-b14a800c8d1c"],
 " with highest price of anarchy for the cost functions"
}], "Text",
 CellChangeTimes->{{3.773474712959984*^9, 3.773474809197242*^9}, {
  3.7734749662346773`*^9, 
  3.773474969391107*^9}},ExpressionUUID->"6bb30b64-3a72-4e87-920d-\
8266b4f95007"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"c1", "[", "x_", "]"}], ":=", 
   RowBox[{"x", "+", "1"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"c2", "[", "x_", "]"}], ":=", 
  RowBox[{"2", "x"}]}]}], "Input",
 CellChangeTimes->{{3.773474810086417*^9, 
  3.773474810088475*^9}},ExpressionUUID->"413e30c5-b1b8-42dc-8623-\
680262ad977b"],

Cell["and the cost functions with parameter", "Text",
 CellChangeTimes->{{3.7734748116083593`*^9, 
  3.7734748169813643`*^9}},ExpressionUUID->"982ddda4-1ad8-4984-a4da-\
9680daf8f231"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"c1", "[", "x_", "]"}], ":=", 
   RowBox[{"a1", "*", "x"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"c2", "[", "x_", "]"}], ":=", "1"}], ";"}]}], "Input",ExpressionUUI\
D->"3e21747a-a742-49b9-9e55-03f2ae8448f9"],

Cell["(Use the poa function generated by Exercise 2.3)", "Text",
 CellChangeTimes->{{3.773474985764176*^9, 3.773475081334187*^9}, {
  3.773475274868451*^9, 
  3.773475274991811*^9}},ExpressionUUID->"2903d093-952e-45e7-be50-\
8cd25315ec0e"],

Cell[CellGroupData[{

Cell["Solution", "Subsection",
 CellChangeTimes->{{3.773474834684375*^9, 
  3.773474844653222*^9}},ExpressionUUID->"a0021e1b-6742-41fa-aaa5-\
2b4d63d16efa"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "The", " ", "price", " ", "of", " ", "anarchy", " ", "function", " ", 
    "generated", " ", "by", " ", 
    RowBox[{"Ex", ".", " ", "2.3"}], " ", "for", " ", "the", " ", "functions",
     " ", "without"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"poa", "=", 
     RowBox[{"Piecewise", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", " ", 
           RowBox[{"r", " ", "<=", " ", 
            RowBox[{"1", "/", "4"}]}]}], "}"}], ",", " ", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"24", "*", 
              RowBox[{"r", "^", "2"}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], " ", "+", " ", 
              RowBox[{"8", "*", "r"}], " ", "+", " ", 
              RowBox[{"8", "*", 
               RowBox[{"r", "^", "2"}]}]}], ")"}]}], ",", " ", "\n", "    ", 
           RowBox[{"Inequality", "[", 
            RowBox[{
             RowBox[{"1", "/", "4"}], ",", " ", "Less", ",", " ", "r", ",", 
             " ", "LessEqual", ",", " ", 
             RowBox[{"1", "/", "2"}]}], "]"}]}], "}"}]}], "}"}], ",", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"8", "*", "r", "*", 
          RowBox[{"(", 
           RowBox[{"1", " ", "+", " ", "r"}], ")"}]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], " ", "+", " ", 
          RowBox[{"8", "*", "r"}], " ", "+", " ", 
          RowBox[{"8", "*", 
           RowBox[{"r", "^", "2"}]}]}], ")"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Compute", " ", "the", " ", "maximal", " ", "PoA"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Maximize", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"poa", ",", 
       RowBox[{"r", "\[GreaterEqual]", "0"}]}], "}"}], ",", "r"}], "]"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "The", " ", "price", " ", "of", " ", "anarchy", " ", "function", " ", 
     "generated", " ", "by", " ", 
     RowBox[{"Ex", ".", " ", "2.3"}], " ", "for", " ", "the", " ", 
     "functions", " ", "with", " ", "parameter"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"poa", "=", 
     RowBox[{"Piecewise", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"4", "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"4", "*", "a1", "*", "r"}]}], ")"}]}], ",", 
           RowBox[{
            RowBox[{"a1", "*", "r"}], "\[Equal]", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"4", "*", 
            RowBox[{"a1", "^", "2"}], "*", 
            RowBox[{"r", "^", "2"}]}], ",", 
           RowBox[{
            RowBox[{"2", "*", "a1", "*", "r"}], "\[Equal]", "1"}]}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{
            RowBox[{"2", "*", "a1", "*", "r"}], "\[LessEqual]", "1"}]}], 
          "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"4", "*", 
              RowBox[{"a1", "^", "2"}], "*", 
              RowBox[{"r", "^", "2"}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"4", "*", "a1", "*", "r"}]}], ")"}]}], ",", 
           RowBox[{
            RowBox[{"1", "/", "2"}], "\[LessEqual]", 
            RowBox[{"a1", "*", "r"}], "\[LessEqual]", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"2", "*", 
              RowBox[{"a1", "^", "2"}], "*", 
              RowBox[{"r", "^", "2"}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"2", "*", "a1", "*", "r"}], "+", 
              RowBox[{"2", "*", 
               RowBox[{"a1", "^", "2"}], "*", 
               RowBox[{"r", "^", "2"}]}]}], ")"}]}], ",", 
           RowBox[{
            RowBox[{"a1", "*", "r"}], "\[LessEqual]", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"4", "*", "a1", "*", "r"}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"4", "*", "a1", "*", "r"}]}], ")"}]}], ",", 
           RowBox[{
            RowBox[{"a1", "*", "r"}], "\[GreaterEqual]", "1"}]}], "}"}], ",", 
         
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"4", "*", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "1"}], "+", 
                RowBox[{"a1", "*", "r"}], "+", 
                RowBox[{
                 RowBox[{"a1", "^", "2"}], "*", 
                 RowBox[{"r", "^", "2"}]}]}], ")"}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"4", "*", "a1", "*", "r"}]}], ")"}]}], ",", 
           RowBox[{
            RowBox[{"2", "*", "a1", "*", "r"}], "\[GreaterEqual]", "1"}]}], 
          "}"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"2", "*", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            RowBox[{"a1", "*", "r"}], "+", 
            RowBox[{
             RowBox[{"a1", "^", "2"}], "*", 
             RowBox[{"r", "^", "2"}]}]}], ")"}]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          RowBox[{"2", "*", "a1", "*", "r"}], "+", 
          RowBox[{"2", "*", 
           RowBox[{"a1", "^", "2"}], "*", 
           RowBox[{"r", "^", "2"}]}]}], ")"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "Compute", " ", "maximal", " ", "PoA", " ", "depending", " ", "on", " ", 
     "a1"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"Simplify", "[", 
    RowBox[{"Maximize", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"poa", ",", 
        RowBox[{"r", "\[GreaterEqual]", "0"}], ",", 
        RowBox[{"a1", "\[GreaterEqual]", "0"}]}], "}"}], ",", " ", "r"}], 
     "]"}], "]"}], "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.773474905126252*^9, 3.773474953556787*^9}, 
   3.773475006412838*^9, {3.773475084552232*^9, 3.773475226858284*^9}, {
   3.7734752782701273`*^9, 3.77347527843646*^9}, {3.773475348685964*^9, 
   3.773475397712077*^9}},
 CellLabel->
  "In[385]:=",ExpressionUUID->"eadff47b-42c8-4974-9843-93e461e7c94e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox["6", "5"], ",", 
   RowBox[{"{", 
    RowBox[{"r", "\[Rule]", 
     FractionBox["1", "2"]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.773475227427108*^9, 3.773475281396289*^9, {3.773475372719844*^9, 
   3.7734753983755493`*^9}},
 CellLabel->
  "Out[386]=",ExpressionUUID->"f21a6c24-2ebc-4c32-ad6a-51690ebc2ee8"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {"1", 
          RowBox[{"a1", "\[Equal]", "0"}]},
         {
          FractionBox["4", "3"], 
          RowBox[{"a1", ">", "0"}]},
         {
          RowBox[{"-", "\[Infinity]"}], 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False], ",", 
   RowBox[{"{", 
    RowBox[{"r", "\[Rule]", 
     TagBox[GridBox[{
        {"\[Piecewise]", GridBox[{
           {"1", 
            RowBox[{"a1", "\[Equal]", "0"}]},
           {
            FractionBox["1", "a1"], 
            RowBox[{"a1", ">", "0"}]},
           {"Indeterminate", 
            TagBox["True",
             "PiecewiseDefault",
             AutoDelete->True]}
          },
          AllowedDimensions->{2, Automatic},
          Editable->True,
          
          GridBoxAlignment->{
           "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
          
          GridBoxItemSize->{
           "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{1.}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.84]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}},
          Selectable->True]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxItemSize->{
        "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
         "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.35]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      "Piecewise",
      DeleteWithContents->True,
      Editable->False,
      SelectWithContents->True,
      Selectable->False]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.773475227427108*^9, 3.773475281396289*^9, {3.773475372719844*^9, 
   3.7734753984537563`*^9}},
 CellLabel->
  "Out[388]=",ExpressionUUID->"3ca214d1-c2df-4ce2-9c87-ac90077bc92c"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Exercise 2:", "Section",
 CellChangeTimes->{{3.7734754196828823`*^9, 3.773475422981485*^9}, {
  3.7734759609088163`*^9, 
  3.773475961210992*^9}},ExpressionUUID->"5a53829a-52c1-4d4a-b9f2-\
f1e94f1985ff"],

Cell[CellGroupData[{

Cell["a)", "Subsection",
 CellChangeTimes->{{3.773475447278586*^9, 
  3.773475451954727*^9}},ExpressionUUID->"16fcb098-691b-4e93-a344-\
096ec4e838a9"],

Cell[TextData[{
 "Use the code from Exercise 4.2c) to setup and print the convex program to \
compute a Wardrop equilibrium. Use the Minimize[ ] function to solve the \
convex program (in dependence of ",
 Cell[BoxData[
  FormBox["r", TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "f60f864d-fc64-4098-8482-e1c19c8c5546"],
 ").\nRecall, that Minimize expects a list containing {objective, \
constraint1, constraint2, ...} as first argument. To concatenate lists, use \
the function Join[ list1, list2 ] or the short form list1~Join~list2.\nUse \
the existing list flowvars as second argument for Minimize."
}], "Text",
 CellChangeTimes->{{3.773475453419643*^9, 
  3.7734756435327044`*^9}},ExpressionUUID->"45061265-2998-4176-ad4a-\
1f295e2c8b73"],

Cell[CellGroupData[{

Cell["Solution", "Subsubsection",
 CellChangeTimes->{{3.77347567973923*^9, 
  3.7734756829386663`*^9}},ExpressionUUID->"a32fceca-2953-4c35-9ea4-\
47f5b1b3a20b"],

Cell["Execute all solution of Exercise 4.2. first.", "Text",
 CellChangeTimes->{{3.773475756933524*^9, 3.773475766483945*^9}, {
  3.773475869387998*^9, 
  3.77347587123323*^9}},ExpressionUUID->"6bcf0901-7581-4a02-9260-\
2f4a8819d38f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"solution", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{"Minimize", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"{", "objective", "}"}], "~", "Join", "~", "flowconditions", 
       "~", "Join", "~", "nonnegconditions"}], ",", "flowvars"}], "]"}], ",", 
    
    RowBox[{"Assumptions", "\[Rule]", 
     RowBox[{"r", "\[GreaterEqual]", "0"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.773475749442498*^9, 3.77347575103787*^9}, 
   3.773475827668173*^9, {3.773475879592847*^9, 3.773475881954183*^9}, {
   3.77347591870015*^9, 3.773475923287711*^9}},
 CellLabel->
  "In[436]:=",ExpressionUUID->"525ed868-4df7-4f50-8d2b-45528c881e68"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          SuperscriptBox["r", "2"], 
          RowBox[{"r", "\[LessEqual]", "1"}]},
         {
          RowBox[{
           FractionBox["1", "4"], " ", "r", " ", 
           RowBox[{"(", 
            RowBox[{"4", "+", "r"}], ")"}]}], 
          RowBox[{"r", ">", "2"}]},
         {
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           RowBox[{"2", " ", "r"}]}], 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"f", "[", "1", "]"}], "\[Rule]", 
      TagBox[GridBox[{
         {"\[Piecewise]", GridBox[{
            {"1", 
             RowBox[{"1", "<", "r", "\[LessEqual]", "2"}]},
            {
             FractionBox["r", "2"], 
             RowBox[{
              RowBox[{"r", "\[Equal]", "0"}], "||", 
              RowBox[{"r", ">", "2"}]}]},
            {"r", 
             TagBox["True",
              "PiecewiseDefault",
              AutoDelete->True]}
           },
           AllowedDimensions->{2, Automatic},
           Editable->True,
           
           GridBoxAlignment->{
            "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           
           GridBoxItemSize->{
            "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{1.}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.84]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.35]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "Piecewise",
       DeleteWithContents->True,
       Editable->False,
       SelectWithContents->True,
       Selectable->False]}], ",", 
     RowBox[{
      RowBox[{"f", "[", "2", "]"}], "\[Rule]", 
      TagBox[GridBox[{
         {"\[Piecewise]", GridBox[{
            {
             RowBox[{
              RowBox[{"-", "1"}], "+", "r"}], 
             RowBox[{"1", "<", "r", "\[LessEqual]", "2"}]},
            {
             FractionBox["r", "2"], 
             RowBox[{"r", ">", "2"}]},
            {"0", 
             TagBox["True",
              "PiecewiseDefault",
              AutoDelete->True]}
           },
           AllowedDimensions->{2, Automatic},
           Editable->True,
           
           GridBoxAlignment->{
            "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           
           GridBoxItemSize->{
            "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{1.}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.84]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.35]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "Piecewise",
       DeleteWithContents->True,
       Editable->False,
       SelectWithContents->True,
       Selectable->False]}], ",", 
     RowBox[{
      RowBox[{"f", "[", "3", "]"}], "\[Rule]", 
      TagBox[GridBox[{
         {"\[Piecewise]", GridBox[{
            {
             RowBox[{"2", "-", "r"}], 
             RowBox[{"1", "\[LessEqual]", "r", "\[LessEqual]", "2"}]},
            {"r", 
             RowBox[{"r", "<", "1"}]},
            {"0", 
             TagBox["True",
              "PiecewiseDefault",
              AutoDelete->True]}
           },
           AllowedDimensions->{2, Automatic},
           Editable->True,
           
           GridBoxAlignment->{
            "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           
           GridBoxItemSize->{
            "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{1.}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.84]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.35]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "Piecewise",
       DeleteWithContents->True,
       Editable->False,
       SelectWithContents->True,
       Selectable->False]}], ",", 
     RowBox[{
      RowBox[{"f", "[", "4", "]"}], "\[Rule]", 
      TagBox[GridBox[{
         {"\[Piecewise]", GridBox[{
            {
             RowBox[{
              RowBox[{"-", "1"}], "+", "r"}], 
             RowBox[{"1", "\[LessEqual]", "r", "\[LessEqual]", "2"}]},
            {
             FractionBox["r", "2"], 
             RowBox[{"r", ">", "2"}]},
            {"0", 
             TagBox["True",
              "PiecewiseDefault",
              AutoDelete->True]}
           },
           AllowedDimensions->{2, Automatic},
           Editable->True,
           
           GridBoxAlignment->{
            "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           
           GridBoxItemSize->{
            "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{1.}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.84]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.35]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "Piecewise",
       DeleteWithContents->True,
       Editable->False,
       SelectWithContents->True,
       Selectable->False]}], ",", 
     RowBox[{
      RowBox[{"f", "[", "5", "]"}], "\[Rule]", 
      TagBox[GridBox[{
         {"\[Piecewise]", GridBox[{
            {"1", 
             RowBox[{"1", "\[LessEqual]", "r", "\[LessEqual]", "2"}]},
            {
             FractionBox["r", "2"], 
             RowBox[{"r", ">", "2"}]},
            {"r", 
             TagBox["True",
              "PiecewiseDefault",
              AutoDelete->True]}
           },
           AllowedDimensions->{2, Automatic},
           Editable->True,
           
           GridBoxAlignment->{
            "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           
           GridBoxItemSize->{
            "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{1.}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.84]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}},
           Selectable->True]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.35]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       "Piecewise",
       DeleteWithContents->True,
       Editable->False,
       SelectWithContents->True,
       Selectable->False]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.773475827927541*^9, {3.7734758757362547`*^9, 3.773475884662075*^9}, 
   3.773475925712759*^9},
 CellLabel->
  "Out[436]=",ExpressionUUID->"5d57a67a-e3df-40af-8eae-c511aacd18af"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["b)", "Subsection",
 CellChangeTimes->{{3.77347589859164*^9, 
  3.773475899884803*^9}},ExpressionUUID->"d7234121-c2f2-4cd1-8ca0-\
abe2eeb5e839"],

Cell["\<\
Create a Manipulate[ ] environment, that lets you set a demand rate \
\[OpenCurlyDoubleQuote]rate\[CloseCurlyDoubleQuote] and solves the convec \
program from a) with the given rate.
You might need to use a replacement rule to create flow-conditions that \
actually contain the manipulated demand rate rather than r, write for example:\
\>", "Text",
 CellChangeTimes->{{3.773476001578457*^9, 
  3.7734761474561577`*^9}},ExpressionUUID->"4213de7a-82d0-4d30-af96-\
b945420f4e6c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"fc", "=", 
   RowBox[{"flowconditions", "/.", 
    RowBox[{"r", "\[Rule]", "rate"}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.7734761486066513`*^9, 
  3.77347614860883*^9}},ExpressionUUID->"57fc1107-ced1-4c45-b875-\
01ea61f268ec"],

Cell["\<\
and use the fc in the Minimize function instead.

Create a graph with edge weights that contain the flow values computed by the \
convex program as EdgeWeight to visualize the solution.\
\>", "Text",
 CellChangeTimes->{{3.7734761525999517`*^9, 
  3.773476241517355*^9}},ExpressionUUID->"b406a79d-cd30-46d0-ad68-\
39314394eb2a"],

Cell[CellGroupData[{

Cell["Solution", "Subsubsection",
 CellChangeTimes->{{3.773476242588512*^9, 
  3.773476245613193*^9}},ExpressionUUID->"0b1f00e5-f108-4cf1-abbb-\
d3d1f5a5f56a"],

Cell["\<\
See the notebook wardropConvexProgram.nb for a complete solution.\
\>", "Text",
 CellChangeTimes->{{3.773476263811171*^9, 
  3.7734762780459642`*^9}},ExpressionUUID->"53639c25-c597-444c-8874-\
0ea4077a303b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Compute", " ", "and", " ", "print", " ", "the", " ", "solution"}],
    " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", "\"\<Solution:\>\"", "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{
     "Create", " ", "new", " ", "flowconditions", " ", "vector", " ", "that", 
      " ", "depends", " ", "on", " ", "the", " ", "\"\<rate\>\"", " ", 
      "variable", " ", "of", " ", "the", " ", "Manipulate", " ", "function"}],
      " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"fc", "=", 
       RowBox[{"flowconditions", "/.", 
        RowBox[{"r", "\[Rule]", "rate"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Execute", " ", "the", " ", "actual", " ", "convex", " ", 
        "optimization"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"solution", "=", 
       RowBox[{"Minimize", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"{", "objective", "}"}], "~", "Join", "~", "fc", "~", 
          "Join", "~", "nonnegconditions"}], ",", "flowvars"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Extract", " ", "optimal", " ", "value", " ", "and", " ", "the", " ", 
        "optimal", " ", "solution", " ", "from", " ", "the", " ", "solution", 
        " ", "variable"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"optvalue", "=", 
       RowBox[{"solution", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"optflow", "=", 
       RowBox[{"solution", "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "Create", " ", "Arrays", " ", "that", " ", "describe", " ", "the", " ",
         "labels", " ", "and", " ", "the", " ", "style", " ", "of", " ", 
        "the", " ", "edges"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"edgeweights", "=", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"Table", "[", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"edges", "[", 
             RowBox[{"[", "e", "]"}], "]"}], "\[Rule]", 
            RowBox[{"f", "[", "e", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"e", ",", "1", ",", "m"}], "}"}]}], "]"}], ")"}], "/.", 
        "optflow"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"edgestyle", "=", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"Table", "[", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"edges", "[", 
             RowBox[{"[", "e", "]"}], "]"}], "\[Rule]", " ", 
            RowBox[{"Directive", "[", 
             RowBox[{
              RowBox[{"Thickness", "[", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"1", "/", "2"}], "+", 
                  RowBox[{"f", "[", "e", "]"}]}], ")"}], "/", "50"}], "]"}], 
              ",", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"f", "[", "e", "]"}], "\[Equal]", "0"}], ",", "Gray",
                 ",", "Blue"}], "]"}]}], "]"}]}], ",", " ", 
           RowBox[{"{", 
            RowBox[{"e", ",", "1", ",", "m"}], "}"}]}], " ", "]"}], ")"}], "/.",
         "optflow"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{"Create", " ", "the", " ", "actual", " ", "graph"}], ",", " ", 
        RowBox[{
        "by", " ", "copying", " ", "the", " ", "input", " ", "graph", " ", 
         "and", " ", "equipping", " ", "it", " ", "with", " ", "EdgeWeights", 
         " ", "and", " ", "Labels"}]}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Graph", "[", 
       RowBox[{"graph", ",", 
        RowBox[{"EdgeWeight", "\[Rule]", "edgeweights"}], ",", 
        RowBox[{"EdgeLabels", "\[Rule]", "\"\<EdgeWeight\>\""}], ",", " ", 
        RowBox[{"VertexLabels", "\[Rule]", "Automatic"}], ",", " ", 
        RowBox[{"EdgeStyle", "\[Rule]", "edgestyle"}]}], "]"}]}], 
     "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"rate", ",", "0", ",", "4", ",", 
       RowBox[{"1", "/", "1000"}]}], "}"}]}], "]"}]}]}]], "Input",ExpressionUU\
ID->"5910ab68-dab6-43d9-8621-f45f19eaa3d0"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Open  ]]
},
WindowSize->{808, 857},
WindowMargins->{{Automatic, 545}, {38, Automatic}},
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 186, 3, 98, "Title",ExpressionUUID->"52cb39b7-d154-47e4-bd39-4907ec58e3a0"],
Cell[CellGroupData[{
Cell[791, 29, 157, 3, 67, "Section",ExpressionUUID->"6e889ae3-9d5b-48f9-83c8-a591e15c8a2b"],
Cell[951, 34, 564, 13, 58, "Text",ExpressionUUID->"6bb30b64-3a72-4e87-920d-8266b4f95007"],
Cell[1518, 49, 333, 10, 52, "Input",ExpressionUUID->"413e30c5-b1b8-42dc-8623-680262ad977b"],
Cell[1854, 61, 183, 3, 35, "Text",ExpressionUUID->"982ddda4-1ad8-4984-a4da-9680daf8f231"],
Cell[2040, 66, 266, 8, 52, "Input",ExpressionUUID->"3e21747a-a742-49b9-9e55-03f2ae8448f9"],
Cell[2309, 76, 239, 4, 35, "Text",ExpressionUUID->"2903d093-952e-45e7-be50-8cd25315ec0e"],
Cell[CellGroupData[{
Cell[2573, 84, 156, 3, 54, "Subsection",ExpressionUUID->"a0021e1b-6742-41fa-aaa5-2b4d63d16efa"],
Cell[CellGroupData[{
Cell[2754, 91, 6882, 188, 388, "Input",ExpressionUUID->"eadff47b-42c8-4974-9843-93e461e7c94e"],
Cell[9639, 281, 376, 11, 51, "Output",ExpressionUUID->"f21a6c24-2ebc-4c32-ad6a-51690ebc2ee8"],
Cell[10018, 294, 3790, 107, 75, "Output",ExpressionUUID->"3ca214d1-c2df-4ce2-9c87-ac90077bc92c"]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[13869, 408, 209, 4, 53, "Section",ExpressionUUID->"5a53829a-52c1-4d4a-b9f2-f1e94f1985ff"],
Cell[CellGroupData[{
Cell[14103, 416, 150, 3, 54, "Subsection",ExpressionUUID->"16fcb098-691b-4e93-a344-096ec4e838a9"],
Cell[14256, 421, 769, 15, 127, "Text",ExpressionUUID->"45061265-2998-4176-ad4a-1f295e2c8b73"],
Cell[CellGroupData[{
Cell[15050, 440, 160, 3, 45, "Subsubsection",ExpressionUUID->"a32fceca-2953-4c35-9ea4-47f5b1b3a20b"],
Cell[15213, 445, 234, 4, 35, "Text",ExpressionUUID->"6bcf0901-7581-4a02-9260-2f4a8819d38f"],
Cell[CellGroupData[{
Cell[15472, 453, 675, 16, 73, "Input",ExpressionUUID->"525ed868-4df7-4f50-8d2b-45528c881e68"],
Cell[16150, 471, 11949, 330, 145, "Output",ExpressionUUID->"5d57a67a-e3df-40af-8eae-c511aacd18af"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[28160, 808, 149, 3, 54, "Subsection",ExpressionUUID->"d7234121-c2f2-4cd1-8ca0-abe2eeb5e839"],
Cell[28312, 813, 487, 9, 104, "Text",ExpressionUUID->"4213de7a-82d0-4d30-af96-b945420f4e6c"],
Cell[28802, 824, 267, 7, 30, "Input",ExpressionUUID->"57fc1107-ced1-4c45-b875-01ea61f268ec"],
Cell[29072, 833, 337, 8, 104, "Text",ExpressionUUID->"b406a79d-cd30-46d0-ad68-39314394eb2a"],
Cell[CellGroupData[{
Cell[29434, 845, 159, 3, 45, "Subsubsection",ExpressionUUID->"0b1f00e5-f108-4cf1-abbb-d3d1f5a5f56a"],
Cell[29596, 850, 217, 5, 35, "Text",ExpressionUUID->"53639c25-c597-444c-8874-0ea4077a303b"],
Cell[29816, 857, 4391, 102, 451, "Input",ExpressionUUID->"5910ab68-dab6-43d9-8621-f45f19eaa3d0"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Open  ]]
}
]
*)

