(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     21492,        579]
NotebookOptionsPosition[     16313,        490]
NotebookOutlinePosition[     16666,        506]
CellTagsIndexPosition[     16623,        503]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Session 0 - Basics", "Title",
 CellChangeTimes->{{3.773309006098401*^9, 3.773309016780425*^9}, {
  3.773309075394765*^9, 3.773309081361457*^9}, {3.77331082501626*^9, 
  3.7733108252453537`*^9}, {3.7733954728290167`*^9, 
  3.773395473354205*^9}},ExpressionUUID->"4610fc67-a2ee-4100-a35c-\
ba501dc99d89"],

Cell[CellGroupData[{

Cell["Basic Computations", "Section",
 CellChangeTimes->{{3.773309052249756*^9, 
  3.773309061484764*^9}},ExpressionUUID->"1d8a971d-6e45-4b9d-91b8-\
ffca6c437c02"],

Cell["\<\
Click anywhere white space and type something to create a new input cell.
Press Shift+Enter/Shift+Return to evaluate the current cell. This creates a \
new output cell with the results.\
\>", "Text",
 CellChangeTimes->{{3.773309140200143*^9, 
  3.773309239275744*^9}},ExpressionUUID->"b8baba4c-5b66-44a6-b4a8-\
eb19cb565e0b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"1", "+", "2"}]], "Input",
 CellChangeTimes->{{3.7733092428156147`*^9, 3.773309249715592*^9}},
 CellLabel->
  "In[151]:=",ExpressionUUID->"ad7a7333-188c-40de-996f-0cd07c92dfc8"],

Cell[BoxData["3"], "Output",
 CellChangeTimes->{3.773309251234848*^9},
 CellLabel->
  "Out[151]=",ExpressionUUID->"a122f90f-b78d-4710-968a-bd0478525ece"]
}, Open  ]],

Cell["Every undefined symbol is used as a symbolic variable.", "Text",
 CellChangeTimes->{{3.773309266940744*^9, 
  3.773309326976437*^9}},ExpressionUUID->"bb327475-e485-4efe-8a5d-\
b02d3738349c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"4", "+", 
  RowBox[{"x", "*", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", "x"}], "+", 
     RowBox[{"6", "x"}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.773309329590706*^9, 3.7733093405339737`*^9}},
 CellLabel->
  "In[152]:=",ExpressionUUID->"52c08a8d-5ca9-4a3d-9d96-59112598df06"],

Cell[BoxData[
 RowBox[{"4", "+", 
  RowBox[{"8", " ", 
   SuperscriptBox["x", "2"]}]}]], "Output",
 CellChangeTimes->{3.773309341648219*^9},
 CellLabel->
  "Out[152]=",ExpressionUUID->"3377a0da-58e5-40d8-bff6-6d492c369b91"]
}, Open  ]],

Cell["\<\
Assign values to variables by using =.
All variables are in general global variables, valid in all further \
computations, even in different cells and notebooks!\
\>", "Text",
 CellChangeTimes->{{3.773309353716154*^9, 3.773309395047962*^9}, 
   3.773309507614366*^9},ExpressionUUID->"16ac5b5a-11b6-42eb-9128-\
0a8c87fa7479"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"y", "=", 
  RowBox[{
   RowBox[{"5", "x"}], "+", "7"}]}], "\[IndentingNewLine]", 
 RowBox[{"y", "*", 
  RowBox[{"y", "/", "x"}]}]}], "Input",
 CellChangeTimes->{{3.773309400114481*^9, 3.7733094239351997`*^9}},
 CellLabel->
  "In[153]:=",ExpressionUUID->"4b69c82a-924e-4cd2-94e9-06f1b6c5b9b2"],

Cell[BoxData[
 RowBox[{"7", "+", 
  RowBox[{"5", " ", "x"}]}]], "Output",
 CellChangeTimes->{3.7733094261855288`*^9},
 CellLabel->
  "Out[153]=",ExpressionUUID->"8292410f-ca98-4f1f-ae51-b1e7e135a4d4"],

Cell[BoxData[
 FractionBox[
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"7", "+", 
     RowBox[{"5", " ", "x"}]}], ")"}], "2"], "x"]], "Output",
 CellChangeTimes->{3.773309426189749*^9},
 CellLabel->
  "Out[154]=",ExpressionUUID->"930616c4-24b7-44d5-bb4f-05e3f6bd9031"]
}, Open  ]],

Cell["\<\
To unset the value of a variable and to use it symbolic again, use Unset\
\>", "Text",
 CellChangeTimes->{{3.7733101267946167`*^9, 
  3.773310154187193*^9}},ExpressionUUID->"0d665784-d6ab-4016-ad17-\
c870d085ce6a"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"y", "=", "5"}], "\[IndentingNewLine]", 
 RowBox[{"y", "^", "2"}], "\[IndentingNewLine]", 
 RowBox[{"Unset", "[", "y", 
  "]"}], "\[IndentingNewLine]", "y", "\[IndentingNewLine]", 
 RowBox[{"y", "^", "2"}]}], "Input",
 CellChangeTimes->{{3.773310156178316*^9, 3.77331016957483*^9}},
 CellLabel->
  "In[160]:=",ExpressionUUID->"253e1c10-efb8-4244-88fd-d6def982fb51"],

Cell[BoxData["5"], "Output",
 CellChangeTimes->{3.773310170138186*^9},
 CellLabel->
  "Out[160]=",ExpressionUUID->"a3020f49-9ec3-4537-81f1-01c3e9cb394d"],

Cell[BoxData["25"], "Output",
 CellChangeTimes->{3.7733101701471643`*^9},
 CellLabel->
  "Out[161]=",ExpressionUUID->"b8ea031c-f7b7-409b-b52a-acea55999b16"],

Cell[BoxData["y"], "Output",
 CellChangeTimes->{3.7733101701548357`*^9},
 CellLabel->
  "Out[163]=",ExpressionUUID->"ca41fbb8-5cee-480e-826b-3bb42ee31dfd"],

Cell[BoxData[
 SuperscriptBox["y", "2"]], "Output",
 CellChangeTimes->{3.773310170164703*^9},
 CellLabel->
  "Out[164]=",ExpressionUUID->"44522cce-ba2b-4ac9-9784-8dbf1a64f68b"]
}, Open  ]],

Cell["\<\
Mathematica contains many build-in functions and symbols for constants (e.g. \
Pi), functions (e.g. Cos) and even complete Algorithm (e.g. FindMaximumFlow). \
Built-in functions start with a capital letter.
Hover any function with the mouse and click the (i) to show the help\
\>", "Text",
 CellChangeTimes->{{3.773309531812234*^9, 3.773309626415606*^9}, {
  3.773309825839056*^9, 
  3.773309899253375*^9}},ExpressionUUID->"e341f3cc-2d0b-4161-b412-\
7f0a09fa7b65"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Cos", "[", "Pi", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Expand", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"x", "+", "1"}], ")"}], "^", "6"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"CompleteGraph", "[", "5", "]"}]}], "Input",
 CellChangeTimes->{{3.7733095968033257`*^9, 3.7733096400132513`*^9}, {
  3.773309729192452*^9, 3.773309732856518*^9}, {3.77330976508156*^9, 
  3.7733097708795357`*^9}, {3.77330980460178*^9, 3.773309807834077*^9}},
 CellLabel->
  "In[156]:=",ExpressionUUID->"af55a64a-ab28-4231-841a-bef503d413a2"],

Cell[BoxData[
 RowBox[{"-", "1"}]], "Output",
 CellChangeTimes->{3.7733096378207397`*^9, 3.773309808095489*^9},
 CellLabel->
  "Out[156]=",ExpressionUUID->"cef44ea5-ae47-454e-9057-44798534f0db"],

Cell[BoxData[
 RowBox[{"1", "+", 
  RowBox[{"6", " ", "x"}], "+", 
  RowBox[{"15", " ", 
   SuperscriptBox["x", "2"]}], "+", 
  RowBox[{"20", " ", 
   SuperscriptBox["x", "3"]}], "+", 
  RowBox[{"15", " ", 
   SuperscriptBox["x", "4"]}], "+", 
  RowBox[{"6", " ", 
   SuperscriptBox["x", "5"]}], "+", 
  SuperscriptBox["x", "6"]}]], "Output",
 CellChangeTimes->{3.7733096378207397`*^9, 3.773309808107114*^9},
 CellLabel->
  "Out[157]=",ExpressionUUID->"09e72bb5-d398-4d22-8b3a-9c7bfcf1baad"],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{1, 2, 3, 4, 5}, {Null, 
       SparseArray[
       Automatic, {5, 5}, 0, {
        1, {{0, 4, 8, 12, 16, 20}, {{2}, {3}, {4}, {5}, {1}, {3}, {4}, {5}, {
          1}, {2}, {4}, {5}, {1}, {2}, {3}, {5}, {1}, {2}, {3}, {4}}}, 
         Pattern}]}, {GraphLayout -> "CircularEmbedding"}]]}, 
    TagBox[
     GraphicsGroupBox[
      GraphicsComplexBox[{{-0.9510565162951538, 
       0.30901699437494834`}, {-0.5877852522924727, -0.8090169943749468}, {
       0.5877852522924737, -0.8090169943749481}, {0.9510565162951533, 
       0.30901699437494634`}, {-7.044813998280222*^-16, 1.}}, {
        {Hue[0.6, 0.7, 0.5], Opacity[0.7], 
         {Arrowheads[0.], ArrowBox[{1, 2}, 0.021812234931106983`]}, 
         {Arrowheads[0.], ArrowBox[{1, 3}, 0.021812234931106983`]}, 
         {Arrowheads[0.], ArrowBox[{1, 4}, 0.021812234931106983`]}, 
         {Arrowheads[0.], ArrowBox[{1, 5}, 0.021812234931106983`]}, 
         {Arrowheads[0.], ArrowBox[{2, 3}, 0.021812234931106983`]}, 
         {Arrowheads[0.], ArrowBox[{2, 4}, 0.021812234931106983`]}, 
         {Arrowheads[0.], ArrowBox[{2, 5}, 0.021812234931106983`]}, 
         {Arrowheads[0.], ArrowBox[{3, 4}, 0.021812234931106983`]}, 
         {Arrowheads[0.], ArrowBox[{3, 5}, 0.021812234931106983`]}, 
         {Arrowheads[0.], ArrowBox[{4, 5}, 0.021812234931106983`]}}, 
        {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[0.7]}], 
         DiskBox[1, 0.021812234931106983], DiskBox[2, 0.021812234931106983], 
         DiskBox[3, 0.021812234931106983], DiskBox[4, 0.021812234931106983], 
         DiskBox[5, 0.021812234931106983]}}]],
     MouseAppearanceTag["NetworkGraphics"]],
    AllowKernelInitialization->False]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FormatType->TraditionalForm,
  FrameTicks->None]], "Output",
 CellChangeTimes->{3.7733096378207397`*^9, 3.773309808166484*^9},
 CellLabel->
  "Out[158]=",ExpressionUUID->"fb5821fc-aa2c-47ed-9ca8-60bff8bdcdb5"]
}, Open  ]],

Cell["\<\
Arguments of functions are given in [ ], multiple arguments are separated \
with commas\
\>", "Text",
 CellChangeTimes->{{3.7733099031834173`*^9, 3.773309941995895*^9}, {
  3.773310103837484*^9, 
  3.773310104798216*^9}},ExpressionUUID->"af648798-ef35-4db3-98be-\
909e2e038d6b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"t", "*", 
     RowBox[{"x", "^", "2"}]}], "+", 
    RowBox[{"Log", "[", "x", "]"}]}], ",", "x"}], "]"}]], "Input",
 CellChangeTimes->{{3.7733099600570593`*^9, 3.773309975099626*^9}},
 CellLabel->
  "In[159]:=",ExpressionUUID->"b9e57439-8f64-4aa3-b8e5-353b9838a874"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "x"}], "+", 
  FractionBox[
   RowBox[{"t", " ", 
    SuperscriptBox["x", "3"]}], "3"], "+", 
  RowBox[{"x", " ", 
   RowBox[{"Log", "[", "x", "]"}]}]}]], "Output",
 CellChangeTimes->{3.773309975785499*^9},
 CellLabel->
  "Out[159]=",ExpressionUUID->"afca52c1-c3e8-4ee5-bc48-54b0e5fe498e"]
}, Open  ]],

Cell["\<\
In Mathematica, almost everything is a functions, so are loops and conditions\
\
\>", "Text",
 CellChangeTimes->{{3.7733101850468616`*^9, 
  3.7733102055589647`*^9}},ExpressionUUID->"c0e3c931-9209-4e45-bef9-\
ed4df83535f5"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"For", "[", 
  RowBox[{
   RowBox[{"i", "=", "1"}], ",", 
   RowBox[{"i", "\[LessEqual]", "5"}], ",", 
   RowBox[{"i", "++"}], ",", 
   RowBox[{"Print", "[", "i", "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"y", "=", "42"}], "\[IndentingNewLine]", 
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"y", ">", "0"}], ",", 
   RowBox[{"Log", "[", "y", "]"}], ",", "0"}], "]"}]}], "Input",
 CellChangeTimes->{{3.77331020901877*^9, 3.7733102787053337`*^9}},
 CellLabel->
  "In[165]:=",ExpressionUUID->"72b1856b-514c-4271-a0f5-45c54edef764"],

Cell[CellGroupData[{

Cell[BoxData["1"], "Print",
 CellChangeTimes->{3.773310280640407*^9},
 CellLabel->
  "During evaluation of \
In[165]:=",ExpressionUUID->"77ac76f6-573d-4412-bfa7-1fc32cd781a6"],

Cell[BoxData["2"], "Print",
 CellChangeTimes->{3.7733102806449957`*^9},
 CellLabel->
  "During evaluation of \
In[165]:=",ExpressionUUID->"d35e334a-20a1-42ba-a489-80f51f534918"],

Cell[BoxData["3"], "Print",
 CellChangeTimes->{3.773310280652108*^9},
 CellLabel->
  "During evaluation of \
In[165]:=",ExpressionUUID->"438c5fcf-dbb8-4b58-b8eb-05429067c911"],

Cell[BoxData["4"], "Print",
 CellChangeTimes->{3.773310280655272*^9},
 CellLabel->
  "During evaluation of \
In[165]:=",ExpressionUUID->"46191d9a-9afd-4fbb-ae45-8ec20cd552fb"],

Cell[BoxData["5"], "Print",
 CellChangeTimes->{3.773310280658396*^9},
 CellLabel->
  "During evaluation of \
In[165]:=",ExpressionUUID->"646ef3dc-2ad7-4057-ab51-d36fc3edca37"]
}, Open  ]],

Cell[BoxData["42"], "Output",
 CellChangeTimes->{3.773310280661426*^9},
 CellLabel->
  "Out[166]=",ExpressionUUID->"c630d491-49c0-4b25-b5cb-f29da6dc5364"],

Cell[BoxData[
 RowBox[{"Log", "[", "42", "]"}]], "Output",
 CellChangeTimes->{3.7733102806688013`*^9},
 CellLabel->
  "Out[167]=",ExpressionUUID->"ee2a22a7-04d2-4a5e-920a-0af3b46bc8ca"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Notebook Formatting", "Section",
 CellChangeTimes->{{3.773310305559074*^9, 
  3.773310315795529*^9}},ExpressionUUID->"7c71c298-5572-4774-ac9a-\
73e68fb2081a"],

Cell["\<\
When creating a new cell in a notebook, it is a input cell by default. Using \
Format -> Style -> (...) in the menu allows to create cells of different \
styles (e.g., text cells like this or headlines).
Inside an input cell, comments can be created by enclosing the comment in (* \
.... *).
Normally, every computation results in an output line. To suppress an output, \
end the line with a ;
The print functions allows to create output everywhere (e.g., inside other \
functions like the If-Function)\
\>", "Text",
 CellChangeTimes->{{3.7733103203900013`*^9, 
  3.773310512915807*^9}},ExpressionUUID->"43877168-44d2-4095-b8d7-\
7615916efaec"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"This", " ", "is", " ", "a", " ", "comment"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"x", "+", "2"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "The", " ", "next", " ", "line", " ", "generates", " ", "no", " ", 
     "output"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"y", "=", 
     RowBox[{"x", "+", 
      RowBox[{"Log", "[", "x", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "The", " ", "next", " ", "line", " ", "generates", " ", "output"}], " ", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{"y", "^", "2"}]}]}]], "Input",
 CellChangeTimes->{{3.7733105158870792`*^9, 3.773310590277215*^9}},
 CellLabel->
  "In[168]:=",ExpressionUUID->"5301b22c-2ccf-45a3-90a9-f6c869230aa1"],

Cell[BoxData[
 RowBox[{"2", "+", "x"}]], "Output",
 CellChangeTimes->{3.773310590985959*^9},
 CellLabel->
  "Out[168]=",ExpressionUUID->"12f1fc73-35aa-4464-b05c-5d3b2d728dbe"],

Cell[BoxData[
 SuperscriptBox[
  RowBox[{"(", 
   RowBox[{"x", "+", 
    RowBox[{"Log", "[", "x", "]"}]}], ")"}], "2"]], "Output",
 CellChangeTimes->{3.773310590990327*^9},
 CellLabel->
  "Out[170]=",ExpressionUUID->"4e137e27-c8d1-4d6c-b64c-7f5374c4dae5"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Numerics", "Section",
 CellChangeTimes->{{3.773310597672062*^9, 
  3.773310603357111*^9}},ExpressionUUID->"1a2f8ba4-0614-4ed3-8177-\
3766f22112c3"],

Cell["\<\
In general every computation is performed analytically (with some \
exceptions). To get a numerical value of a function, use the N[ ] function.\
\>", "Text",
 CellChangeTimes->{{3.77331060634083*^9, 
  3.773310711063448*^9}},ExpressionUUID->"89b32290-f373-43b5-91f1-\
47fecc7a07bd"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"y", "=", 
  RowBox[{
   RowBox[{"1", "/", "42"}], "+", 
   RowBox[{"1", "/", "10000000000"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"N", "[", "y", "]"}], "\[IndentingNewLine]", 
 RowBox[{"y", "=", 
  RowBox[{"Log", "[", "42", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"N", "[", "y", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Exp", "[", "y", "]"}]}], "Input",
 CellChangeTimes->{{3.77331071965184*^9, 3.773310771870791*^9}},
 CellLabel->
  "In[182]:=",ExpressionUUID->"bfe90be0-d654-4b98-a3d7-31f7742dac68"],

Cell[BoxData[
 FractionBox["5000000021", "210000000000"]], "Output",
 CellChangeTimes->{{3.7733107302117662`*^9, 3.7733107726355267`*^9}},
 CellLabel->
  "Out[182]=",ExpressionUUID->"1d197b43-b546-4d88-bf93-97090b3954ae"],

Cell[BoxData["0.02380952390952381`"], "Output",
 CellChangeTimes->{{3.7733107302117662`*^9, 3.7733107726449013`*^9}},
 CellLabel->
  "Out[183]=",ExpressionUUID->"30976d87-197a-4c20-982b-4bbd0883d99d"],

Cell[BoxData[
 RowBox[{"Log", "[", "42", "]"}]], "Output",
 CellChangeTimes->{{3.7733107302117662`*^9, 3.773310772648796*^9}},
 CellLabel->
  "Out[184]=",ExpressionUUID->"22877832-b59e-4cdb-a3c4-17836dd2974f"],

Cell[BoxData["3.7376696182833684`"], "Output",
 CellChangeTimes->{{3.7733107302117662`*^9, 3.773310772652637*^9}},
 CellLabel->
  "Out[185]=",ExpressionUUID->"d056f3b5-01c7-45e8-b23e-44ed760c2c13"],

Cell[BoxData["42"], "Output",
 CellChangeTimes->{{3.7733107302117662`*^9, 3.773310772656501*^9}},
 CellLabel->
  "Out[186]=",ExpressionUUID->"410d108d-16d3-423b-9c98-2acfcab7fe75"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1680, 936},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 308, 5, 98, "Title",ExpressionUUID->"4610fc67-a2ee-4100-a35c-ba501dc99d89"],
Cell[CellGroupData[{
Cell[913, 31, 163, 3, 67, "Section",ExpressionUUID->"1d8a971d-6e45-4b9d-91b8-ffca6c437c02"],
Cell[1079, 36, 335, 7, 58, "Text",ExpressionUUID->"b8baba4c-5b66-44a6-b4a8-eb19cb565e0b"],
Cell[CellGroupData[{
Cell[1439, 47, 200, 4, 30, "Input",ExpressionUUID->"ad7a7333-188c-40de-996f-0cd07c92dfc8"],
Cell[1642, 53, 153, 3, 34, "Output",ExpressionUUID->"a122f90f-b78d-4710-968a-bd0478525ece"]
}, Open  ]],
Cell[1810, 59, 196, 3, 35, "Text",ExpressionUUID->"bb327475-e485-4efe-8a5d-b02d3738349c"],
Cell[CellGroupData[{
Cell[2031, 66, 314, 9, 30, "Input",ExpressionUUID->"52c08a8d-5ca9-4a3d-9d96-59112598df06"],
Cell[2348, 77, 223, 6, 34, "Output",ExpressionUUID->"3377a0da-58e5-40d8-bff6-6d492c369b91"]
}, Open  ]],
Cell[2586, 86, 334, 7, 58, "Text",ExpressionUUID->"16ac5b5a-11b6-42eb-9128-0a8c87fa7479"],
Cell[CellGroupData[{
Cell[2945, 97, 317, 8, 52, "Input",ExpressionUUID->"4b69c82a-924e-4cd2-94e9-06f1b6c5b9b2"],
Cell[3265, 107, 200, 5, 34, "Output",ExpressionUUID->"8292410f-ca98-4f1f-ae51-b1e7e135a4d4"],
Cell[3468, 114, 272, 8, 53, "Output",ExpressionUUID->"930616c4-24b7-44d5-bb4f-05e3f6bd9031"]
}, Open  ]],
Cell[3755, 125, 224, 5, 35, "Text",ExpressionUUID->"0d665784-d6ab-4016-ad17-c870d085ce6a"],
Cell[CellGroupData[{
Cell[4004, 134, 389, 8, 115, "Input",ExpressionUUID->"253e1c10-efb8-4244-88fd-d6def982fb51"],
Cell[4396, 144, 153, 3, 34, "Output",ExpressionUUID->"a3020f49-9ec3-4537-81f1-01c3e9cb394d"],
Cell[4552, 149, 156, 3, 34, "Output",ExpressionUUID->"b8ea031c-f7b7-409b-b52a-acea55999b16"],
Cell[4711, 154, 155, 3, 34, "Output",ExpressionUUID->"ca41fbb8-5cee-480e-826b-3bb42ee31dfd"],
Cell[4869, 159, 176, 4, 34, "Output",ExpressionUUID->"44522cce-ba2b-4ac9-9784-8dbf1a64f68b"]
}, Open  ]],
Cell[5060, 166, 474, 9, 58, "Text",ExpressionUUID->"e341f3cc-2d0b-4161-b412-7f0a09fa7b65"],
Cell[CellGroupData[{
Cell[5559, 179, 558, 12, 73, "Input",ExpressionUUID->"af55a64a-ab28-4231-841a-bef503d413a2"],
Cell[6120, 193, 194, 4, 34, "Output",ExpressionUUID->"cef44ea5-ae47-454e-9057-44798534f0db"],
Cell[6317, 199, 491, 14, 34, "Output",ExpressionUUID->"09e72bb5-d398-4d22-8b3a-9c7bfcf1baad"],
Cell[6811, 215, 2111, 39, 360, "Output",ExpressionUUID->"fb5821fc-aa2c-47ed-9ca8-60bff8bdcdb5"]
}, Open  ]],
Cell[8937, 257, 288, 7, 35, "Text",ExpressionUUID->"af648798-ef35-4db3-98be-909e2e038d6b"],
Cell[CellGroupData[{
Cell[9250, 268, 343, 9, 30, "Input",ExpressionUUID->"b9e57439-8f64-4aa3-b8e5-353b9838a874"],
Cell[9596, 279, 328, 10, 54, "Output",ExpressionUUID->"afca52c1-c3e8-4ee5-bc48-54b0e5fe498e"]
}, Open  ]],
Cell[9939, 292, 233, 6, 35, "Text",ExpressionUUID->"c0e3c931-9209-4e45-bef9-ed4df83535f5"],
Cell[CellGroupData[{
Cell[10197, 302, 558, 14, 73, "Input",ExpressionUUID->"72b1856b-514c-4271-a0f5-45c54edef764"],
Cell[CellGroupData[{
Cell[10780, 320, 175, 4, 24, "Print",ExpressionUUID->"77ac76f6-573d-4412-bfa7-1fc32cd781a6"],
Cell[10958, 326, 177, 4, 24, "Print",ExpressionUUID->"d35e334a-20a1-42ba-a489-80f51f534918"],
Cell[11138, 332, 175, 4, 24, "Print",ExpressionUUID->"438c5fcf-dbb8-4b58-b8eb-05429067c911"],
Cell[11316, 338, 175, 4, 24, "Print",ExpressionUUID->"46191d9a-9afd-4fbb-ae45-8ec20cd552fb"],
Cell[11494, 344, 175, 4, 24, "Print",ExpressionUUID->"646ef3dc-2ad7-4057-ab51-d36fc3edca37"]
}, Open  ]],
Cell[11684, 351, 154, 3, 34, "Output",ExpressionUUID->"c630d491-49c0-4b25-b5cb-f29da6dc5364"],
Cell[11841, 356, 185, 4, 34, "Output",ExpressionUUID->"ee2a22a7-04d2-4a5e-920a-0af3b46bc8ca"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[12075, 366, 164, 3, 67, "Section",ExpressionUUID->"7c71c298-5572-4774-ac9a-73e68fb2081a"],
Cell[12242, 371, 654, 13, 104, "Text",ExpressionUUID->"43877168-44d2-4095-b8d7-7615916efaec"],
Cell[CellGroupData[{
Cell[12921, 388, 843, 22, 136, "Input",ExpressionUUID->"5301b22c-2ccf-45a3-90a9-f6c869230aa1"],
Cell[13767, 412, 175, 4, 34, "Output",ExpressionUUID->"12f1fc73-35aa-4464-b05c-5d3b2d728dbe"],
Cell[13945, 418, 255, 7, 34, "Output",ExpressionUUID->"4e137e27-c8d1-4d6c-b64c-7f5374c4dae5"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[14249, 431, 153, 3, 67, "Section",ExpressionUUID->"1a2f8ba4-0614-4ed3-8177-3766f22112c3"],
Cell[14405, 436, 292, 6, 35, "Text",ExpressionUUID->"89b32290-f373-43b5-91f1-47fecc7a07bd"],
Cell[CellGroupData[{
Cell[14722, 446, 529, 12, 115, "Input",ExpressionUUID->"bfe90be0-d654-4b98-a3d7-31f7742dac68"],
Cell[15254, 460, 221, 4, 51, "Output",ExpressionUUID->"1d197b43-b546-4d88-bf93-97090b3954ae"],
Cell[15478, 466, 200, 3, 34, "Output",ExpressionUUID->"30976d87-197a-4c20-982b-4bbd0883d99d"],
Cell[15681, 471, 209, 4, 34, "Output",ExpressionUUID->"22877832-b59e-4cdb-a3c4-17836dd2974f"],
Cell[15893, 477, 197, 3, 34, "Output",ExpressionUUID->"d056f3b5-01c7-45e8-b23e-44ed760c2c13"],
Cell[16093, 482, 180, 3, 34, "Output",ExpressionUUID->"410d108d-16d3-423b-9c98-2acfcab7fe75"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

