(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     32270,        896]
NotebookOptionsPosition[     27587,        816]
NotebookOutlinePosition[     27940,        832]
CellTagsIndexPosition[     27897,        829]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Session 1 - How To: Functions and Lists", "Title",
 CellChangeTimes->{{3.773310848718794*^9, 
  3.773310883315194*^9}},ExpressionUUID->"f01da7bd-3780-44f8-934e-\
a217ff54b300"],

Cell[CellGroupData[{

Cell["Defining Functions", "Section",
 CellChangeTimes->{{3.773310895143091*^9, 
  3.773310924406393*^9}},ExpressionUUID->"2eb29078-6b71-4e24-9520-\
055a3cfc7f65"],

Cell["\<\
The symbol := creates a delayed evaluation. When the lhs is called, it is \
evaluated at the time of the call\
\>", "Text",
 CellChangeTimes->{{3.773310947927788*^9, 3.773310950332376*^9}, {
  3.7733109863567047`*^9, 
  3.773311069373414*^9}},ExpressionUUID->"18596e89-f91a-4f01-b123-\
5dca48d11f7e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Define", " ", "x", " ", "and", " ", "y", " ", "as", " ", "the", " ", 
     "current", " ", "time"}], " ", "-", " ", 
    RowBox[{"but", " ", "y", " ", "is", " ", "evaluated", " ", "delayed"}]}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"x", "=", "Now"}], "\[IndentingNewLine]", 
   RowBox[{"y", ":=", "Now"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Print", " ", "x", " ", "and", " ", "y"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Print", "[", 
    RowBox[{
    "\"\<x: \>\"", ",", " ", "x", ",", " ", "\"\< y: \>\"", ",", "y"}], "]"}],
    "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Wait", " ", "for", " ", "1", " ", "Second"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Pause", "[", "1", "]"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"y", " ", "is", " ", "evaluated", " ", "again"}], ",", " ", 
     RowBox[{"and", " ", "has", " ", "a", " ", "new", " ", "value"}]}], " ", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{"Print", "[", 
    RowBox[{
    "\"\<x: \>\"", ",", " ", "x", ",", " ", "\"\< y: \>\"", ",", "y"}], "]"}],
    "\[IndentingNewLine]", 
   RowBox[{"Pause", "[", "1", "]"}], "\[IndentingNewLine]", 
   RowBox[{"Print", "[", 
    RowBox[{
    "\"\<x: \>\"", ",", " ", "x", ",", " ", "\"\< y: \>\"", ",", "y"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.7733110732521276`*^9, 3.773311094264821*^9}, {
  3.7733111289765787`*^9, 3.773311254941152*^9}, {3.773377611055697*^9, 
  3.7733776124762783`*^9}},ExpressionUUID->"dec49c06-d2d0-46e4-8e60-\
7d06f73bc4c1"],

Cell[BoxData[
 TemplateBox[{RowBox[{"\"Sun 28 Jul 2019 16:00:55\"", 
     StyleBox[
      RowBox[{"\"GMT+\"", "\[InvisibleSpace]", 
        StyleBox["2.`", NumberMarks -> False, StripOnInput -> False]}], 
      FontColor -> GrayLevel[0.5]]}],RowBox[{"DateObject", "[", 
     RowBox[{
       RowBox[{"{", 
         RowBox[{
          "2019", ",", "7", ",", "28", ",", "16", ",", "0", ",", 
           "55.551586`8.497271436737238"}], "}"}], ",", "\"Instant\"", ",", 
       "\"Gregorian\"", ",", "2.`"}], "]"}]},
  "DateObject",
  Editable->False]], "Output",
 CellChangeTimes->{3.773311255571929*^9},
 CellLabel->
  "Out[203]=",ExpressionUUID->"499dcbb5-8823-4c25-837b-2a60d8b85931"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"x: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{RowBox[{"\"Sun 28 Jul 2019 16:00:55\"", 
       StyleBox[
        RowBox[{"\"GMT+\"", "\[InvisibleSpace]", 
          StyleBox["2.`", NumberMarks -> False, StripOnInput -> False]}], 
        FontColor -> GrayLevel[0.5]]}],RowBox[{"DateObject", "[", 
       RowBox[{
         RowBox[{"{", 
           
           RowBox[{"2019", ",", "7", ",", "28", ",", "16", ",", "0", ",", 
             "55.551586`8.497271436737238"}], "}"}], ",", "\"Instant\"", ",", 
         "\"Gregorian\"", ",", "2.`"}], "]"}]},
    "DateObject",
    Editable->False], "\[InvisibleSpace]", "\<\" y: \"\>", 
   "\[InvisibleSpace]", 
   TemplateBox[{RowBox[{"\"Sun 28 Jul 2019 16:00:55\"", 
       StyleBox[
        RowBox[{"\"GMT+\"", "\[InvisibleSpace]", 
          StyleBox["2.`", NumberMarks -> False, StripOnInput -> False]}], 
        FontColor -> GrayLevel[0.5]]}],RowBox[{"DateObject", "[", 
       RowBox[{
         RowBox[{"{", 
           
           RowBox[{"2019", ",", "7", ",", "28", ",", "16", ",", "0", ",", 
             "55.552771`8.497280700801673"}], "}"}], ",", "\"Instant\"", ",", 
         "\"Gregorian\"", ",", "2.`"}], "]"}]},
    "DateObject",
    Editable->False]}],
  SequenceForm["x: ", 
   DateObject[{2019, 7, 28, 16, 0, 55.551586`8.497271436737238}, "Instant", 
    "Gregorian", 2.], " y: ", 
   DateObject[{2019, 7, 28, 16, 0, 55.552771`8.497280700801673}, "Instant", 
    "Gregorian", 2.]],
  Editable->False]], "Print",
 CellChangeTimes->{3.773311255577065*^9},
 CellLabel->
  "During evaluation of \
In[203]:=",ExpressionUUID->"7533a48c-39ee-490d-a607-cd97e9bd96ff"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"x: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{RowBox[{"\"Sun 28 Jul 2019 16:00:55\"", 
       StyleBox[
        RowBox[{"\"GMT+\"", "\[InvisibleSpace]", 
          StyleBox["2.`", NumberMarks -> False, StripOnInput -> False]}], 
        FontColor -> GrayLevel[0.5]]}],RowBox[{"DateObject", "[", 
       RowBox[{
         RowBox[{"{", 
           
           RowBox[{"2019", ",", "7", ",", "28", ",", "16", ",", "0", ",", 
             "55.551586`8.497271436737238"}], "}"}], ",", "\"Instant\"", ",", 
         "\"Gregorian\"", ",", "2.`"}], "]"}]},
    "DateObject",
    Editable->False], "\[InvisibleSpace]", "\<\" y: \"\>", 
   "\[InvisibleSpace]", 
   TemplateBox[{RowBox[{"\"Sun 28 Jul 2019 16:00:56\"", 
       StyleBox[
        RowBox[{"\"GMT+\"", "\[InvisibleSpace]", 
          StyleBox["2.`", NumberMarks -> False, StripOnInput -> False]}], 
        FontColor -> GrayLevel[0.5]]}],RowBox[{"DateObject", "[", 
       RowBox[{
         RowBox[{"{", 
           
           RowBox[{"2019", ",", "7", ",", "28", ",", "16", ",", "0", ",", 
             "56.556506`8.505057545258234"}], "}"}], ",", "\"Instant\"", ",", 
         "\"Gregorian\"", ",", "2.`"}], "]"}]},
    "DateObject",
    Editable->False]}],
  SequenceForm["x: ", 
   DateObject[{2019, 7, 28, 16, 0, 55.551586`8.497271436737238}, "Instant", 
    "Gregorian", 2.], " y: ", 
   DateObject[{2019, 7, 28, 16, 0, 56.556506`8.505057545258234}, "Instant", 
    "Gregorian", 2.]],
  Editable->False]], "Print",
 CellChangeTimes->{3.773311256561605*^9},
 CellLabel->
  "During evaluation of \
In[203]:=",ExpressionUUID->"93d5c96d-05d7-4027-b160-2ea3b2b83b31"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"x: \"\>", "\[InvisibleSpace]", 
   TemplateBox[{RowBox[{"\"Sun 28 Jul 2019 16:00:55\"", 
       StyleBox[
        RowBox[{"\"GMT+\"", "\[InvisibleSpace]", 
          StyleBox["2.`", NumberMarks -> False, StripOnInput -> False]}], 
        FontColor -> GrayLevel[0.5]]}],RowBox[{"DateObject", "[", 
       RowBox[{
         RowBox[{"{", 
           
           RowBox[{"2019", ",", "7", ",", "28", ",", "16", ",", "0", ",", 
             "55.551586`8.497271436737238"}], "}"}], ",", "\"Instant\"", ",", 
         "\"Gregorian\"", ",", "2.`"}], "]"}]},
    "DateObject",
    Editable->False], "\[InvisibleSpace]", "\<\" y: \"\>", 
   "\[InvisibleSpace]", 
   TemplateBox[{RowBox[{"\"Sun 28 Jul 2019 16:00:57\"", 
       StyleBox[
        RowBox[{"\"GMT+\"", "\[InvisibleSpace]", 
          StyleBox["2.`", NumberMarks -> False, StripOnInput -> False]}], 
        FontColor -> GrayLevel[0.5]]}],RowBox[{"DateObject", "[", 
       RowBox[{
         RowBox[{"{", 
           
           RowBox[{"2019", ",", "7", ",", "28", ",", "16", ",", "0", ",", 
             "57.561225`8.512705001495378"}], "}"}], ",", "\"Instant\"", ",", 
         "\"Gregorian\"", ",", "2.`"}], "]"}]},
    "DateObject",
    Editable->False]}],
  SequenceForm["x: ", 
   DateObject[{2019, 7, 28, 16, 0, 55.551586`8.497271436737238}, "Instant", 
    "Gregorian", 2.], " y: ", 
   DateObject[{2019, 7, 28, 16, 0, 57.561225`8.512705001495378}, "Instant", 
    "Gregorian", 2.]],
  Editable->False]], "Print",
 CellChangeTimes->{3.7733112575644083`*^9},
 CellLabel->
  "During evaluation of \
In[203]:=",ExpressionUUID->"5242d269-b176-4fb7-942f-2858cc3be9e5"]
}, Open  ]]
}, Open  ]],

Cell["\<\
Using the underscore, we can define patterns. Patterns can be used to define \
arguments of a function\
\>", "Text",
 CellChangeTimes->{{3.773311329053914*^9, 
  3.773311375721047*^9}},ExpressionUUID->"64dc042f-41db-427e-9f49-\
0611fe3b81fa"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
  RowBox[{"x", "+", "y"}]}], "\[IndentingNewLine]", 
 RowBox[{"f", "[", 
  RowBox[{"1", ",", "3"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"f", "[", 
  RowBox[{"Pi", ",", 
   RowBox[{
    RowBox[{"-", "2"}], "*", "Pi"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.773311378774597*^9, 3.773311420161446*^9}},
 CellLabel->
  "In[212]:=",ExpressionUUID->"b70d6764-01e9-43ca-bb3d-e2c478c84dca"],

Cell[BoxData["4"], "Output",
 CellChangeTimes->{{3.7733114075102797`*^9, 3.773311420820691*^9}},
 CellLabel->
  "Out[213]=",ExpressionUUID->"59c7f963-80f4-42a7-b3a2-c9f56635c4c3"],

Cell[BoxData[
 RowBox[{"-", "\[Pi]"}]], "Output",
 CellChangeTimes->{{3.7733114075102797`*^9, 3.773311420829276*^9}},
 CellLabel->
  "Out[214]=",ExpressionUUID->"a6a4fec2-9f22-48f0-878d-aa73ff355844"]
}, Open  ]],

Cell["\<\
Functions may depend on undefined symbols and on variables with values. Note \
that the values are evaluated delayed, i.e., if a value of a variable used in \
a function changes, the function changes too.\
\>", "Text",
 CellChangeTimes->{{3.773311455613249*^9, 
  3.773311519405841*^9}},ExpressionUUID->"2e101eb7-6137-42f7-94ef-\
03aa3fba6bc4"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Unset", "[", "a", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"g", "[", "x_", "]"}], ":=", 
  RowBox[{
   RowBox[{"a", "*", "x"}], "-", "1"}]}], "\[IndentingNewLine]", 
 RowBox[{"g", "[", "1", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"a", "=", "5"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"g", "[", "1", "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.773311524675796*^9, 3.773311566977408*^9}},
 CellLabel->
  "In[220]:=",ExpressionUUID->"82ceafc5-dd9a-4c5d-bcc8-485c0fd8c9e5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "1"}], "+", "a"}]], "Output",
 CellChangeTimes->{{3.773311563528657*^9, 3.773311567217833*^9}},
 CellLabel->
  "Out[222]=",ExpressionUUID->"2fe5800f-06f0-440c-b574-ae6b8e60f8d9"],

Cell[BoxData["4"], "Output",
 CellChangeTimes->{{3.773311563528657*^9, 3.773311567226891*^9}},
 CellLabel->
  "Out[224]=",ExpressionUUID->"9e3cc420-49e5-438d-9849-2d4bc78f5e78"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Lists", "Section",
 CellChangeTimes->{{3.773311597217004*^9, 
  3.773311603649796*^9}},ExpressionUUID->"b6b2def9-cdc8-46aa-a9b6-\
7d7ae7f72879"],

Cell["\<\
Lists (or Arrays) are denoted with { }. List entries are accessed with [[ ]].
Lists can contain all kinds of elements (numbers, variables, equations, \
functions ....)\
\>", "Text",
 CellChangeTimes->{{3.773311634393709*^9, 3.77331168973282*^9}, {
  3.7733117331378202`*^9, 
  3.773311749530766*^9}},ExpressionUUID->"4e1b15d3-8c9d-4380-9227-\
bba6a581016d"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"list", " ", "=", " ", 
  RowBox[{"{", 
   RowBox[{"1", ",", 
    RowBox[{"-", "1"}], ",", "12", ",", "4", ",", "42"}], 
   "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"list", "[", 
   RowBox[{"[", "3", "]"}], "]"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Returns", " ", "the", " ", "last", " ", "element", " ", "in", " ", 
    "list"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"list", "[", 
  RowBox[{"[", 
   RowBox[{"-", "1"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"crazylist", "=", 
  RowBox[{"{", 
   RowBox[{"1", ",", "Red", ",", "FindMaximumFlow", ",", 
    RowBox[{
     RowBox[{"x", "^", "2"}], "\[GreaterEqual]", "1"}]}], 
   "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"crazylist", "[", 
  RowBox[{"[", "2", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.773311693240067*^9, 3.773311787190448*^9}},
 CellLabel->
  "In[228]:=",ExpressionUUID->"db3f6b45-d5bd-48df-9b29-fba0b45574d0"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", 
   RowBox[{"-", "1"}], ",", "12", ",", "4", ",", "42"}], "}"}]], "Output",
 CellChangeTimes->{3.7733117295214767`*^9, 3.773311787797348*^9},
 CellLabel->
  "Out[228]=",ExpressionUUID->"d1153579-d958-46e8-97d5-9542035483b8"],

Cell[BoxData["12"], "Output",
 CellChangeTimes->{3.7733117295214767`*^9, 3.773311787808708*^9},
 CellLabel->
  "Out[229]=",ExpressionUUID->"d51e7b40-c81e-4ec0-82d2-f245e7cbc2ec"],

Cell[BoxData["42"], "Output",
 CellChangeTimes->{3.7733117295214767`*^9, 3.773311787812755*^9},
 CellLabel->
  "Out[230]=",ExpressionUUID->"72d330c5-c69c-44d9-96c4-3dbe859a6f2e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", 
   InterpretationBox[
    ButtonBox[
     TooltipBox[
      GraphicsBox[{
        {GrayLevel[0], RectangleBox[{0, 0}]}, 
        {GrayLevel[0], RectangleBox[{1, -1}]}, 
        {RGBColor[1, 0, 0], RectangleBox[{0, -1}, {2, 1}]}},
       AspectRatio->1,
       DefaultBaseStyle->"ColorSwatchGraphics",
       Frame->True,
       FrameStyle->RGBColor[0.6666666666666666, 0., 0.],
       FrameTicks->None,
       ImageSize->
        Dynamic[{
         Automatic, 1.35 CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
          Magnification]}],
       PlotRangePadding->None],
      StyleBox[
       RowBox[{"RGBColor", "[", 
         RowBox[{"1", ",", "0", ",", "0"}], "]"}], NumberMarks -> False]],
     Appearance->None,
     BaseStyle->{},
     BaselinePosition->Baseline,
     ButtonFunction:>With[{Typeset`box$ = EvaluationBox[]}, 
       If[
        Not[
         AbsoluteCurrentValue["Deployed"]], 
        SelectionMove[Typeset`box$, All, Expression]; 
        FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
        FrontEnd`Private`$ColorSelectorInitialColor = RGBColor[1, 0, 0]; 
        FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
        MathLink`CallFrontEnd[
          FrontEnd`AttachCell[Typeset`box$, 
           FrontEndResource["RGBColorValueSelector"], {0, {Left, Bottom}}, {
           Left, Top}, 
           "ClosingActions" -> {
            "SelectionDeparture", "ParentChanged", "EvaluatorQuit"}]]]],
     DefaultBaseStyle->{},
     Evaluator->Automatic,
     Method->"Preemptive"],
    RGBColor[1, 0, 0],
    Editable->False,
    Selectable->False], ",", "FindMaximumFlow", ",", 
   RowBox[{
    SuperscriptBox[
     TemplateBox[{RowBox[{"\"Sun 28 Jul 2019 16:00:55\"", 
         StyleBox[
          RowBox[{"\"GMT+\"", "\[InvisibleSpace]", 
            StyleBox["2.`", NumberMarks -> False, StripOnInput -> False]}], 
          FontColor -> GrayLevel[0.5]]}],RowBox[{"DateObject", "[", 
         RowBox[{
           RowBox[{"{", 
             
             RowBox[{"2019", ",", "7", ",", "28", ",", "16", ",", "0", ",", 
               "55.551586`8.497271436737238"}], "}"}], ",", "\"Instant\"", 
           ",", "\"Gregorian\"", ",", "2.`"}], "]"}]},
      "DateObject",
      Editable->False], "2"], "\[GreaterEqual]", "1"}]}], "}"}]], "Output",
 CellChangeTimes->{3.7733117295214767`*^9, 3.773311787817224*^9},
 CellLabel->
  "Out[231]=",ExpressionUUID->"7034068b-0cc2-4a6b-a7e6-a4b47cf79efa"],

Cell[BoxData[
 InterpretationBox[
  ButtonBox[
   TooltipBox[
    GraphicsBox[{
      {GrayLevel[0], RectangleBox[{0, 0}]}, 
      {GrayLevel[0], RectangleBox[{1, -1}]}, 
      {RGBColor[1, 0, 0], RectangleBox[{0, -1}, {2, 1}]}},
     AspectRatio->1,
     DefaultBaseStyle->"ColorSwatchGraphics",
     Frame->True,
     FrameStyle->RGBColor[0.6666666666666666, 0., 0.],
     FrameTicks->None,
     ImageSize->
      Dynamic[{Automatic, 1.35 CurrentValue["FontCapHeight"]/
        AbsoluteCurrentValue[Magnification]}],
     PlotRangePadding->None],
    StyleBox[
     RowBox[{"RGBColor", "[", 
       RowBox[{"1", ",", "0", ",", "0"}], "]"}], NumberMarks -> False]],
   Appearance->None,
   BaseStyle->{},
   BaselinePosition->Baseline,
   ButtonFunction:>With[{Typeset`box$ = EvaluationBox[]}, 
     If[
      Not[
       AbsoluteCurrentValue["Deployed"]], 
      SelectionMove[Typeset`box$, All, Expression]; 
      FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
      FrontEnd`Private`$ColorSelectorInitialColor = RGBColor[1, 0, 0]; 
      FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
      MathLink`CallFrontEnd[
        FrontEnd`AttachCell[Typeset`box$, 
         FrontEndResource["RGBColorValueSelector"], {0, {Left, Bottom}}, {
         Left, Top}, 
         "ClosingActions" -> {
          "SelectionDeparture", "ParentChanged", "EvaluatorQuit"}]]]],
   DefaultBaseStyle->{},
   Evaluator->Automatic,
   Method->"Preemptive"],
  RGBColor[1, 0, 0],
  Editable->False,
  Selectable->False]], "Output",
 CellChangeTimes->{3.7733117295214767`*^9, 3.773311787826043*^9},
 CellLabel->
  "Out[232]=",ExpressionUUID->"45eacaa8-87d5-41d2-8dc7-820c4d4d98b7"]
}, Open  ]],

Cell["\<\
Lists can be nested to create multi dimensional arrays. Use the function \
MatrixForm (or // MatrixForm at the end a line) to create a nice,  matrix \
output\
\>", "Text",
 CellChangeTimes->{{3.773311818783414*^9, 
  3.773311866916114*^9}},ExpressionUUID->"4d0e6f33-d549-42e7-98a0-\
80af1bffd681"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"matrix", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"MatrixForm", "[", "matrix", "]"}]}], "Input",
 CellChangeTimes->{{3.773311869236331*^9, 3.773311912529636*^9}},
 CellLabel->
  "In[233]:=",ExpressionUUID->"00ec42ba-30b6-49d2-9d10-21875f0ef9d6"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "2"},
     {"3", "4"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.773311912958531*^9},
 CellLabel->
  "Out[234]//MatrixForm=",ExpressionUUID->"cc00f66a-4731-452b-bc12-\
b9d83e957bb9"]
}, Open  ]],

Cell["\<\
Mathematica contains all kinds of list- and matrix functions.\
\>", "Text",
 CellChangeTimes->{{3.7733119527974987`*^9, 
  3.773312016043212*^9}},ExpressionUUID->"a028c65d-ed1a-4a04-b2f3-\
afed5d3230ca"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Dot", " ", "Product"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "4"}], "}"}]}], "}"}], ".", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}]}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "Eigenvalues", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"Eigenvalues", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "4"}], "}"}]}], "}"}], "]"}], "\[IndentingNewLine]", 
   
   RowBox[{"(*", " ", 
    RowBox[{"Sum", " ", "of", " ", "a", " ", 
     RowBox[{"list", "/", "vector"}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"Total", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", 
      RowBox[{"Sqrt", "[", "42", "]"}]}], "}"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.773312018236986*^9, 
  3.773312083363324*^9}},ExpressionUUID->"64da91bf-52cd-4b2f-88c9-\
cbf19d02aea9"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3", ",", "7"}], "}"}]], "Output",
 CellChangeTimes->{{3.773312055349861*^9, 3.773312076033675*^9}},
 CellLabel->
  "Out[237]=",ExpressionUUID->"e5755d62-818c-4123-a861-1f17d7a82ff9"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{"5", "+", 
      SqrtBox["33"]}], ")"}]}], ",", 
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{"5", "-", 
      SqrtBox["33"]}], ")"}]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.773312055349861*^9, 3.773312076044614*^9}},
 CellLabel->
  "Out[238]=",ExpressionUUID->"318915eb-9976-4db0-acc3-1d46fd04dbdd"],

Cell[BoxData[
 RowBox[{"3", "+", 
  SqrtBox["42"]}]], "Output",
 CellChangeTimes->{{3.773312055349861*^9, 3.7733120760488033`*^9}},
 CellLabel->
  "Out[239]=",ExpressionUUID->"cee373cf-801c-4c0e-8380-11b6f0ef1584"]
}, Open  ]],

Cell["\<\
List can be created by functions, e.g., Range, ConstantArray, \
IdentityMatrix,...
Furthermore, arrays can be created by Table or Array\
\>", "Text",
 CellChangeTimes->{{3.7733121129211187`*^9, 
  3.7733121750970182`*^9}},ExpressionUUID->"6d99b141-4f15-49fa-93ee-\
a76468eeb49e"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Range", "[", "10", "]"}], "\[IndentingNewLine]", 
 RowBox[{"ConstantArray", "[", 
  RowBox[{
   RowBox[{"Sqrt", "[", "42", "]"}], ",", "5"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"i", "^", "2"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "1", ",", "5"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"-", "1"}], ")"}], "^", 
     RowBox[{"(", 
      RowBox[{"i", "+", "j"}], ")"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", "5"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "1", ",", "5"}], "}"}]}], "]"}], "//", 
  "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"Array", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Sin", "[", 
     RowBox[{
      RowBox[{"#", "/", "4"}], "*", "Pi"}], "]"}], "&"}], ",", "12"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.773312178748704*^9, 3.773312308349387*^9}},
 CellLabel->
  "In[244]:=",ExpressionUUID->"cabde120-b128-46a7-8708-fc375bfc7dda"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "7", ",", "8", 
   ",", "9", ",", "10"}], "}"}]], "Output",
 CellChangeTimes->{3.773312259692832*^9, 3.773312308644517*^9},
 CellLabel->
  "Out[244]=",ExpressionUUID->"806d3469-8a2e-48d8-886d-624e24f367a6"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   SqrtBox["42"], ",", 
   SqrtBox["42"], ",", 
   SqrtBox["42"], ",", 
   SqrtBox["42"], ",", 
   SqrtBox["42"]}], "}"}]], "Output",
 CellChangeTimes->{3.773312259692832*^9, 3.773312308657619*^9},
 CellLabel->
  "Out[245]=",ExpressionUUID->"e30ab3d7-89cb-4764-bc4e-6c011a4f9f34"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "4", ",", "9", ",", "16", ",", "25"}], "}"}]], "Output",
 CellChangeTimes->{3.773312259692832*^9, 3.773312308665283*^9},
 CellLabel->
  "Out[246]=",ExpressionUUID->"d56c7870-50fe-4898-927a-97b03dedc7f5"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", 
      RowBox[{"-", "1"}], "1", 
      RowBox[{"-", "1"}], "1"},
     {
      RowBox[{"-", "1"}], "1", 
      RowBox[{"-", "1"}], "1", 
      RowBox[{"-", "1"}]},
     {"1", 
      RowBox[{"-", "1"}], "1", 
      RowBox[{"-", "1"}], "1"},
     {
      RowBox[{"-", "1"}], "1", 
      RowBox[{"-", "1"}], "1", 
      RowBox[{"-", "1"}]},
     {"1", 
      RowBox[{"-", "1"}], "1", 
      RowBox[{"-", "1"}], "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.773312259692832*^9, 3.773312308674213*^9},
 CellLabel->
  "Out[247]//MatrixForm=",ExpressionUUID->"ca744297-a029-485d-931d-\
504b3236c175"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox["1", 
    SqrtBox["2"]], ",", "1", ",", 
   FractionBox["1", 
    SqrtBox["2"]], ",", "0", ",", 
   RowBox[{"-", 
    FractionBox["1", 
     SqrtBox["2"]]}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", 
    FractionBox["1", 
     SqrtBox["2"]]}], ",", "0", ",", 
   FractionBox["1", 
    SqrtBox["2"]], ",", "1", ",", 
   FractionBox["1", 
    SqrtBox["2"]], ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{3.773312259692832*^9, 3.773312308682222*^9},
 CellLabel->
  "Out[248]=",ExpressionUUID->"472801a7-2b8f-4f15-a01d-0a0961832d44"]
}, Open  ]],

Cell["\<\
Sometimes it is useful to apply a function to all values of a list rather \
than applying it to the list itself.
Use Map[ ] or /@ for this purpose. \
\>", "Text",
 CellChangeTimes->{{3.773312331086182*^9, 
  3.773312385589917*^9}},ExpressionUUID->"ff89d5b0-d66e-431a-ba60-\
5172a70362eb"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"list", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "7"}],
     "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"func", "[", "x_", "]"}], ":=", 
   RowBox[{
    RowBox[{"x", "^", "2"}], "+", "1"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"func", "/@", "list"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"matrix", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "4"}], "}"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "The", " ", "last", " ", "parameter", " ", "specifies", " ", "the", " ", 
    "level", " ", "on", " ", "which", " ", "the", " ", "function", " ", 
    "should", " ", "be", " ", "applied"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"Map", "[", 
  RowBox[{"func", ",", "matrix", ",", 
   RowBox[{"{", "2", "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.7733123928304462`*^9, 3.773312575782838*^9}},
 CellLabel->
  "In[288]:=",ExpressionUUID->"e6ebff2c-ae91-4d4e-80bb-58d11d57bda1"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2", ",", "5", ",", "10", ",", "17", ",", "26", ",", "37", ",", "50"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.7733124214086933`*^9, {3.773312528523877*^9, 3.773312576419279*^9}},
 CellLabel->
  "Out[290]=",ExpressionUUID->"7391a06e-de02-4ae7-8f97-ae7c58257261"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"10", ",", "17"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.7733124214086933`*^9, {3.773312528523877*^9, 3.773312576430891*^9}},
 CellLabel->
  "Out[292]=",ExpressionUUID->"143e376b-c983-4f0d-884b-edecc06c861e"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1920, 957},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 182, 3, 98, "Title",ExpressionUUID->"f01da7bd-3780-44f8-934e-a217ff54b300"],
Cell[CellGroupData[{
Cell[787, 29, 163, 3, 67, "Section",ExpressionUUID->"2eb29078-6b71-4e24-9520-055a3cfc7f65"],
Cell[953, 34, 310, 7, 35, "Text",ExpressionUUID->"18596e89-f91a-4f01-b123-5dca48d11f7e"],
Cell[CellGroupData[{
Cell[1288, 45, 1675, 40, 241, "Input",ExpressionUUID->"dec49c06-d2d0-46e4-8e60-7d06f73bc4c1"],
Cell[2966, 87, 683, 16, 43, "Output",ExpressionUUID->"499dcbb5-8823-4c25-837b-2a60d8b85931"],
Cell[CellGroupData[{
Cell[3674, 107, 1672, 39, 33, "Print",ExpressionUUID->"7533a48c-39ee-490d-a607-cd97e9bd96ff"],
Cell[5349, 148, 1672, 39, 33, "Print",ExpressionUUID->"93d5c96d-05d7-4027-b160-2ea3b2b83b31"],
Cell[7024, 189, 1674, 39, 33, "Print",ExpressionUUID->"5242d269-b176-4fb7-942f-2858cc3be9e5"]
}, Open  ]]
}, Open  ]],
Cell[8725, 232, 252, 6, 35, "Text",ExpressionUUID->"64dc042f-41db-427e-9f49-0611fe3b81fa"],
Cell[CellGroupData[{
Cell[9002, 242, 480, 13, 73, "Input",ExpressionUUID->"b70d6764-01e9-43ca-bb3d-e2c478c84dca"],
Cell[9485, 257, 179, 3, 34, "Output",ExpressionUUID->"59c7f963-80f4-42a7-b3a2-c9f56635c4c3"],
Cell[9667, 262, 200, 4, 34, "Output",ExpressionUUID->"a6a4fec2-9f22-48f0-878d-aa73ff355844"]
}, Open  ]],
Cell[9882, 269, 354, 7, 35, "Text",ExpressionUUID->"2e101eb7-6137-42f7-94ef-03aa3fba6bc4"],
Cell[CellGroupData[{
Cell[10261, 280, 537, 12, 136, "Input",ExpressionUUID->"82ceafc5-dd9a-4c5d-bcc8-485c0fd8c9e5"],
Cell[10801, 294, 217, 5, 34, "Output",ExpressionUUID->"2fe5800f-06f0-440c-b574-ae6b8e60f8d9"],
Cell[11021, 301, 177, 3, 34, "Output",ExpressionUUID->"9e3cc420-49e5-438d-9849-2d4bc78f5e78"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[11247, 310, 150, 3, 67, "Section",ExpressionUUID->"b6b2def9-cdc8-46aa-a9b6-7d7ae7f72879"],
Cell[11400, 315, 367, 8, 58, "Text",ExpressionUUID->"4e1b15d3-8c9d-4380-9227-bba6a581016d"],
Cell[CellGroupData[{
Cell[11792, 327, 964, 26, 136, "Input",ExpressionUUID->"db3f6b45-d5bd-48df-9b29-fba0b45574d0"],
Cell[12759, 355, 273, 6, 34, "Output",ExpressionUUID->"d1153579-d958-46e8-97d5-9542035483b8"],
Cell[13035, 363, 178, 3, 34, "Output",ExpressionUUID->"d51e7b40-c81e-4ec0-82d2-f245e7cbc2ec"],
Cell[13216, 368, 178, 3, 34, "Output",ExpressionUUID->"72d330c5-c69c-44d9-96c4-3dbe859a6f2e"],
Cell[13397, 373, 2485, 63, 45, "Output",ExpressionUUID->"7034068b-0cc2-4a6b-a7e6-a4b47cf79efa"],
Cell[15885, 438, 1667, 45, 34, "Output",ExpressionUUID->"45eacaa8-87d5-41d2-8dc7-820c4d4d98b7"]
}, Open  ]],
Cell[17567, 486, 307, 7, 35, "Text",ExpressionUUID->"4d0e6f33-d549-42e7-98a0-80af1bffd681"],
Cell[CellGroupData[{
Cell[17899, 497, 447, 12, 52, "Input",ExpressionUUID->"00ec42ba-30b6-49d2-9d10-21875f0ef9d6"],
Cell[18349, 511, 724, 21, 60, "Output",ExpressionUUID->"cc00f66a-4731-452b-bc12-b9d83e957bb9"]
}, Open  ]],
Cell[19088, 535, 213, 5, 35, "Text",ExpressionUUID->"a028c65d-ed1a-4a04-b2f3-afed5d3230ca"],
Cell[CellGroupData[{
Cell[19326, 544, 1119, 32, 136, "Input",ExpressionUUID->"64da91bf-52cd-4b2f-88c9-cbf19d02aea9"],
Cell[20448, 578, 222, 5, 34, "Output",ExpressionUUID->"e5755d62-818c-4123-a861-1f17d7a82ff9"],
Cell[20673, 585, 452, 15, 50, "Output",ExpressionUUID->"318915eb-9976-4db0-acc3-1d46fd04dbdd"],
Cell[21128, 602, 214, 5, 36, "Output",ExpressionUUID->"cee373cf-801c-4c0e-8380-11b6f0ef1584"]
}, Open  ]],
Cell[21357, 610, 289, 7, 58, "Text",ExpressionUUID->"6d99b141-4f15-49fa-93ee-a76468eeb49e"],
Cell[CellGroupData[{
Cell[21671, 621, 1069, 33, 115, "Input",ExpressionUUID->"cabde120-b128-46a7-8708-fc375bfc7dda"],
Cell[22743, 656, 308, 7, 34, "Output",ExpressionUUID->"806d3469-8a2e-48d8-886d-624e24f367a6"],
Cell[23054, 665, 320, 10, 39, "Output",ExpressionUUID->"e30ab3d7-89cb-4764-bc4e-6c011a4f9f34"],
Cell[23377, 677, 252, 5, 34, "Output",ExpressionUUID->"d56c7870-50fe-4898-927a-97b03dedc7f5"],
Cell[23632, 684, 1136, 36, 110, "Output",ExpressionUUID->"ca744297-a029-485d-931d-504b3236c175"],
Cell[24771, 722, 597, 20, 54, "Output",ExpressionUUID->"472801a7-2b8f-4f15-a01d-0a0961832d44"]
}, Open  ]],
Cell[25383, 745, 298, 7, 58, "Text",ExpressionUUID->"ff89d5b0-d66e-431a-ba60-5172a70362eb"],
Cell[CellGroupData[{
Cell[25706, 756, 1176, 33, 136, "Input",ExpressionUUID->"e6ebff2c-ae91-4d4e-80bb-58d11d57bda1"],
Cell[26885, 791, 310, 8, 34, "Output",ExpressionUUID->"7391a06e-de02-4ae7-8f97-ae7c58257261"],
Cell[27198, 801, 349, 10, 34, "Output",ExpressionUUID->"143e376b-c983-4f0d-884b-edecc06c861e"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

